//Chat Bot Motor Andras Bognar 2012
#ifndef ChatH
#define ChatH

#include "..\AnsiString.h"
#include "..\TStringListClass.h"

#define MAXFIRST 1000
#define RULEFIRST "firstrules.txt"
#define RULESECOND "secondrules.txt"
#define UNKNOWNQ "unknownquestions.txt"

class ChatBot{
public:
	ChatBot();
	~ChatBot();
	void sendline(AnsiString line);	//Put a new question to the bot Reply is immediately in 'replytext'
	AnsiString replytext;			//The reply
	void GetBoredMsg();				//The bot is bored because of the user. This gets the next bored message
	void ClientConnect();			//The firs 'say hello' message on start
	
private:
	int responsetime;//Is there any response
	int inactivity;	//inactivity time counter
	
	AnsiString u;//ures string
	AnsiString input;//The user input	
	TStringList* firstrule;//First Rules
	TStringList* secondrule;//Second rules
	TStringList* notunderstand;//Don't understand   reply
	TStringList* unknown;	//unknown question to save
	TStringList* boredmsg;//no activity timeout message
	void reply();
	int RND(int x);
	AnsiString ChatBot::ekezet(AnsiString s);
	int Split(TStringList*parts,AnsiString s);
	int Strc(AnsiString input,AnsiString s,int & oper,int & pos);
	int rule2(AnsiString input,AnsiString rule);
	int SearchHashmark(TStringList*list,AnsiString s);
	int SearchDPoint(TStringList*list,int &pos);
};
#endif
