//Admin Client
#include "../Client_Linux.h"
#include "Chat.h"
#include <list>

//if this defined then the server is compiled as Linux daemon otherwise compiled as an application
#define SERVICEMODE

#define LOG_FILE "log.txt"
#define LOG_CONSOLE

#ifdef SERVICEMODE
	#ifdef LOG_CONSOLE
		#undef LOG_CONSOLE
	#endif
	#define RUNNING_DIR	"/bin/bamessenger/elisabot"
    #define LOCK_FILE	"bame.lock"
#endif

struct Questioner{
	int ID;
	int skey;
	int rkey;
};

class AdminClient : public Client{
public:
	AdminClient();
	~AdminClient();

	//INTERFACE
	void GuiPrint(char* message);
	void ProcessPartner(char*uname, int id, int ON_OFF, unsigned char* photo);	//process partner info loaded from server
	void NotifAuthPassed();
	//void NotifUserOffline();
	//void NotifUnameChg(int ID,char*name);
	//void NotifUremoved(int ID);
	void NotifUstatus(int ID,int state);
	void RouteNotifMsg(int From,int Font,char*message);		//Route command from another client
	//void GuiUpdateNotif();
	void NetDisconnectNotif();
	void NotitErrorCode(int ecode);
	int& getCSkey(int ID);									//key setter, getter functions for ClientApp
	int& getCRkey(int ID);
	int  setCSRkey(int KEY,int ID);
	//void FileHasSentNotif(int ID);
	void FileReceivingNotif(int F,char*name);
	void FileReceivedNotif(int F,char*name);
		
	Questioner*LookUpClient(int id);
	list<Questioner*> QC;	//Questioner clients list
	
	int tmp;		//temporary, dummy
	
	ChatBot* Bot;
};
