//MainForm
#include "MainForm.h"
//Buddy picture
#include "buddy.h"
#include "..\Initialize.h"

//max num of session window
int MAXSESS=5;

MainForm::MainForm(){
	intimer=1;
	Canvas=NULL;
	CreateClientCalled=0;
	RouteEnabled=0;
	InRepaint=0;
	Blinking=0;
	Blinkstate=0;
	AuthPassed=0;
	SpecialGUI=0;
	TryReconnect=0;
	AliveCnt=-60;
	AliveRet=0;
	AutGuiUpdt=0;
	
	GUIsema=new Semaphore(1,1);
	sch=NULL;
	chnum=NULL;
	chstr=NULL;

	CreateSpecial("Bognar Messenger 1.1 Beta",50,50,415,540,2);
}

MainForm::~MainForm(){
	delete GUIsema;
    DestroyForm();
	if(sch)delete[] sch;
	if(chnum)delete[] chnum;
	if(chstr)delete[] chstr;
}

//Build up form
void MainForm::BuildForm(HWND hwnd,HINSTANCE hInst){
	intimer=1;
	hinst=hInst;
	ButtonX=new Button(hwnd,hInst,"X",ButtonXParam);
	ShowWindow(ButtonX->ButtonHwnd,SW_HIDE);
	EditM=new Memo(hwnd,hInst,"",EditMParam);
	EditE=new Memo(hwnd,hInst,"",EditEParam);
	ShowWindow(EditM->MemoHwnd,SW_HIDE);
	ShowWindow(EditE->MemoHwnd,SW_HIDE);
	
	//httr<>
	LabelH=new Label(hwnd,hInst,"Httr",LabelHParam);
	ButtonH1=new Button(hwnd,hInst,"<",ButtonH1Param);
	ButtonH2=new Button(hwnd,hInst,">",ButtonH2Param);
	//Font <>
	LabelF=new Label(hwnd,hInst,"Bet",LabelFParam);
	ButtonF1=new Button(hwnd,hInst,"<",ButtonF1Param);
	ButtonF2=new Button(hwnd,hInst,">",ButtonF2Param);
	//Add partner
	LabelAddP=new Label(hwnd,hInst,"Hozzad+",LabelAddPParam);
	EditAddP=new EditBox(hwnd,hInst,"",EditAddPParam);
	//kpcsere
	ButtonKep=new Button(hwnd,hInst,"Kpcsere",ButtonKepParam);
	//File klds
	OpenDialog1=new TOpenDialog(hwnd);
	Openpic=new TOpenPictureDialog(hwnd);
	//Event for creating critical section for sending.
	
	LabelH->SetDefFont();
	ButtonH1->SetDefFont();
	ButtonH2->SetDefFont();
	LabelF->SetDefFont();
	ButtonF1->SetDefFont();
	ButtonF2->SetDefFont();
	LabelAddP->SetDefFont();
	EditAddP->SetDefFont();
	ButtonKep->SetDefFont();
	
	Timer1=new TimerClass(hwnd,300);
	TScrollBar1=new TScrollBar(hwnd,hInst,"S1",Scroll1Param);
	TScrollBar2=new TScrollBar(hwnd,hInst,"S2",Scroll2Param);
	//TScrollBar1->SetPos(0);
	ScrollPos=0;
	
	TabControl1=new TabControl(hwnd,hInst,"TABS",Tab1Param);
	TabControl1->SetDefFont();
	TabControl1->AddTab("MAIN");
	TAB=0;
	ActSes=NULL;
	
	GIFRoot=ExtractFilePath(Application->ExeName)+"GIF\\";
	Epoi=0;
	cursorState=0;
	echar=0;
	//Create BMPs
	HDC hdc;
	BITMAPINFO bmi;
	BITMAPINFOHEADER* bmih = &(bmi.bmiHeader);
	
	//Create Bitmaps
    hdc=GetDC(hwnd);
    if(!hdc){
		MessageBox(hwnd, TEXT("ERROR: GetDC() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
		return;
	}
	//F ablak Bitmap
    Mhdc =  CreateCompatibleDC ( hdc );
    if(!Mhdc){
		MessageBox(hwnd, TEXT("ERROR: CreateCompatibleDC() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
		return;
	}
    memset( bmih, 0, sizeof(*bmih));
    bmih->biSize = sizeof(BITMAPINFOHEADER);
    bmih->biPlanes = 1;
    bmih->biBitCount = 24;
    bmih->biCompression = BI_RGB;
    bmih->biWidth = MBW;
    bmih->biHeight = MBH;
	Mhbmp = CreateDIBSection(hdc, &bmi, DIB_RGB_COLORS, &DIBport, 0, 0);
    if(!Mhbmp){
		MessageBox(hwnd, TEXT("ERROR: CreateDIBSection() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
		return;
	}
	SelectObject ( Mhdc, Mhbmp );
	//Szerkeszt Bitmap
    MhdcSz =  CreateCompatibleDC ( hdc );
    if(!MhdcSz){
		MessageBox(hwnd, TEXT("ERROR: CreateCompatibleDC() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
		return;
	}
    memset( bmih, 0, sizeof(*bmih));
    bmih->biSize = sizeof(BITMAPINFOHEADER);
    bmih->biPlanes = 1;
    bmih->biBitCount = 24;
    bmih->biCompression = BI_RGB;
    bmih->biWidth = EBW;
    bmih->biHeight = EBH;
	MhbmpSz = CreateDIBSection(hdc, &bmi, DIB_RGB_COLORS, &DIBportSz, 0, 0);
    if(!MhbmpSz){
		MessageBox(hwnd, TEXT("ERROR: CreateDIBSection() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
		return;
	}
	SelectObject ( MhdcSz, MhbmpSz );
	//Small Clipping BITMAP
    MhdcClip =  CreateCompatibleDC ( hdc );
    if(!MhdcClip){
		MessageBox(hwnd, TEXT("ERROR: CreateCompatibleDC() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
		return;
	}
    memset( bmih, 0, sizeof(*bmih));
    bmih->biSize = sizeof(BITMAPINFOHEADER);
    bmih->biPlanes = 1;
    bmih->biBitCount = 24;
    bmih->biCompression = BI_RGB;
    bmih->biWidth = PW;
    bmih->biHeight = PH;
	MhbmpClip = CreateDIBSection(hdc, &bmi, DIB_RGB_COLORS, &DIBportClip, 0, 0);
    if(!MhbmpClip){
		MessageBox(hwnd, TEXT("ERROR: CreateDIBSection() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
		return;
	}
	SelectObject ( MhdcClip, MhbmpClip );
	//Double buffering Bitmap
	hdcDoubleBuf =  CreateCompatibleDC ( hdc );
    if(!hdcDoubleBuf)MessageBox(hwnd, TEXT("ERROR: CreateCompatibleDC() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
	bmpDoubleBuf = CreateCompatibleBitmap ( hdc,FRW,FRH );
    if(!bmpDoubleBuf)MessageBox(hwnd, TEXT("ERROR: CreateCompatibleBitmap() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
	SelectObject ( hdcDoubleBuf, bmpDoubleBuf );
    ReleaseDC(hwnd,hdc);
	//Paint all to white
	HBRUSH hBrush = CreateSolidBrush(mColor);
	RECT r;
	r.left=0;
	r.top=0;
	r.right=MBW;
	r.bottom=MBH;
    FillRect(Mhdc,&r,hBrush);
	DeleteObject(hBrush);
	hBrush = CreateSolidBrush(eColor);
	r.left=0;
	r.top=0;
	r.right=EBW;
	r.bottom=EBH;
	FillRect(MhdcSz,&r,hBrush);
    DeleteObject(hBrush);
	
	//Cursors
	mcx=5;mcy=5;
	ecx=5;ecy=5;
	vecx=5;vecy=5;
	
	
	//FONTs
	//Disable Font smoothing if ON
	int pv=0;
	if(!SystemParametersInfo(SPI_GETFONTSMOOTHING, 0, &pv, 0)){
		MessageBox(hwnd, TEXT("ERROR: SystemParametersInfo() failed ! 1"), TEXT("Error"), MB_APPLMODAL | MB_ICONSTOP);
		return;
	}
	if (pv > 0){
		//pv > 0 means font smoothing is on.
		//Disable Font Smoothing
		if(!SystemParametersInfo(SPI_SETFONTSMOOTHING, 0, &pv, SPIF_UPDATEINIFILE)){
			MessageBox(hwnd, TEXT("ERROR: SystemParametersInfo() failed ! 2"), TEXT("Error"), MB_APPLMODAL | MB_ICONSTOP);
			return;
		}
	}
	SysFont = CreateFont(-11,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, VARIABLE_PITCH,TEXT("Tahoma"));
	ErrorFont = CreateFont(-11,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, VARIABLE_PITCH,TEXT("Tahoma"));
	mFont1 = CreateFont(-11,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, VARIABLE_PITCH,TEXT("Tahoma"));
	mFont2 = CreateFont(-11,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, VARIABLE_PITCH,TEXT("Times New Roman"));
	mFont3 = CreateFont(-11,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, VARIABLE_PITCH,TEXT("Calibri"));
	mFont4 = CreateFont(-11,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, VARIABLE_PITCH,TEXT("Arial"));
	mFont5 = CreateFont(-11,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, VARIABLE_PITCH,TEXT("Courier"));
	mFont6 = CreateFont(-11,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, VARIABLE_PITCH,TEXT("Helvetica"));
	mFont7 = CreateFont(-15,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, VARIABLE_PITCH,TEXT("Helvetica"));
	mFont8 = CreateFont(-15,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, VARIABLE_PITCH,TEXT("Courier"));
	mFont9 = CreateFont(-11,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, VARIABLE_PITCH,TEXT("Arial"));
	mFont10 = CreateFont(-11,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, VARIABLE_PITCH,TEXT("Times New Roman"));
	NameF = CreateFont(-15,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, VARIABLE_PITCH,TEXT("Tahoma"));
	
	//Htterek
	//Frames
	FrameRoot=ExtractFilePath(Application->ExeName)+"Frames\\";
	AnsiString FrameRootSearch=FrameRoot+"*.*";
	HANDLE HFind;
	WIN32_FIND_DATA FindFileData;
	HFind=FindFirstFile(FrameRootSearch.String,&FindFileData);
	AnsiString* pstr;
	if(HFind == INVALID_HANDLE_VALUE){
		ShowMessage("FATAL ERROR: No Frames found\n");
		return;
	}else{
		if(!(FindFileData.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)){
			pstr=new AnsiString();
			strcpy(pstr->String,FindFileData.cFileName);
			Frames.push_back(pstr);
		}
		while(FindNextFile(HFind,&FindFileData)){
			if(!(FindFileData.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)){
				pstr=new AnsiString();
				strcpy(pstr->String,FindFileData.cFileName);
				Frames.push_back(pstr);
			}
		}
		FindClose(HFind);
	}
	Canvas=new CanvasClass(hwnd,FRX,FRY,FRW,FRH);
	
	//Load INI file
	INIfile=ExtractFilePath(Application->ExeName)+"BAchat.ini";
	if(!FileExists(INIfile)){
		ShowMessage("Nincs mg regisztrcis fjlod teleptve (BAchat.ini)\nTeleptened kell egyet, nyomj OK-t!");
		if(SpecifyINIfile()==0){
			ShowMessage("ERROR: Nem adtl meg rvnyes regisztrcis fjlt\ngy nem tudod hasznlni a programot.");
			return;
		}
	}
	
	if(LoadFromIni(INIfile.String)){
		ShowMessage("ERROR: Slyos hiba: INI file hibs!\nFATAL ERROR: INI file is corrupted!");
		return;
	}
	
	//Set frame
	SetFrame();
	//Set fonts for windows
	ChangeEditFont();
	SetMainFont(i->EditFont);
	
	//Init default partner face picture
	int x,y,cnt=0;
	DefPartnerPic=new BYTE[PW*PH*3];
	memset(DefPartnerPic,0,PW*PH*3);
	for(y=0;y<PH;y++)
		for(x=0;x<PW;x++){
			#ifdef BUDDYPICGEN
			if(x==y){
				DefPartnerPic[(x+PW*y)*3]=0xFF;
				DefPartnerPic[(x+PW*y)*3+1]=0x00;
				DefPartnerPic[(x+PW*y)*3+2]=0x0;
			}else if((x<3)||(x>47)||(y<3)||(y>47)){
				DefPartnerPic[(x+PW*y)*3]=0x00;
				DefPartnerPic[(x+PW*y)*3+1]=0xFF;
				DefPartnerPic[(x+PW*y)*3+2]=0x0;
			}else{
				DefPartnerPic[(x+PW*y)*3]=0x00;
				DefPartnerPic[(x+PW*y)*3+1]=0x00;
				DefPartnerPic[(x+PW*y)*3+2]=0x00;
			}
			#else
			DefPartnerPic[(x+PW*y)*3+2]=buddy[cnt++];
			DefPartnerPic[(x+PW*y)*3+1]=buddy[cnt++];
			DefPartnerPic[(x+PW*y)*3]=buddy[cnt++];
			#endif
		}
	
	long newsize;
	BYTE* Bbuf = ConvertRGBToBMPBuffer ( DefPartnerPic,PW,PH, &newsize );
	delete DefPartnerPic;
	DefPartnerPic=new BYTE[newsize];
	memcpy(DefPartnerPic,Bbuf,newsize);
	delete Bbuf;
	DefPartnerPicSize=newsize;

	//DRAW MAIN PANEL
	DrawMainPanel();
	ShowWindow(ButtonX->ButtonHwnd,SW_HIDE);
	//InvalidateRect(hwnd,NULL,TRUE);
	
	//Start network
	CreateClient();
	CreateClientCalled=1;
	RouteEnabled=1;
	intimer=0;
	
	LoadChangeFile();
}

//Destroy form
void MainForm::DestroyForm(){
	Timer1->Enabled=false;
	
	//Stop network
	Sleep(1000);
	if(CreateClientCalled&&ClientThreadRun)
		DestroyClient();
	
    DeleteDC(Mhdc);
    DeleteObject(Mhbmp);
	DeleteDC(MhdcSz);
    DeleteObject(MhbmpSz);
	DeleteDC(MhdcClip);
    DeleteObject(MhbmpClip);
	DeleteDC(hdcDoubleBuf);
	DeleteObject(bmpDoubleBuf);
	
	DeleteObject(SysFont);
	DeleteObject(ErrorFont);
	DeleteObject(mFont1);
	DeleteObject(mFont2);
	DeleteObject(mFont3);
	DeleteObject(mFont4);
	DeleteObject(mFont5);
	DeleteObject(mFont6);
	DeleteObject(mFont7);
	DeleteObject(mFont8);
	DeleteObject(mFont9);
	DeleteObject(mFont10);
	DeleteObject(NameF);
	
	AnsiString* str;
	int y;
	for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
		ActSes=(*j);
		for (std::vector<GIF*>::iterator i = ActSes->Objlist.begin(); i != ActSes->Objlist.end(); ++i){
			for(y=0;y<50;y++){
				str=(*i)->kep[y];
				if( str )
					delete str;
			}
			delete (*i);
		}
		ActSes->Objlist.clear();
		if( (*j)->win )delete[] (*j)->win;
		if( (*j)->buf )delete[] (*j)->buf;
		delete ActSes;
	}
	Sessions.clear();
	
	for (std::vector<AnsiString*>::iterator i = Frames.begin(); i != Frames.end(); ++i){
		delete (*i);
	}	
	Frames.clear();

	for (std::vector<Partner*>::iterator i = Partners.begin(); i != Partners.end(); ++i){
		if( (*i)->pic )delete[] (*i)->pic;
		delete (*i);
	}	
	Partners.clear();
	
 	delete ButtonX;
	
	if(intimer)Sleep(500);
	if(intimer)Sleep(500);
	delete Timer1;
	delete TabControl1;
	delete Canvas;
	delete TScrollBar1;
	delete TScrollBar2;
	delete EditM;
	delete EditE;
	delete[] DefPartnerPic;
	
	delete LabelH;
	delete ButtonH1;
	delete ButtonH2;
	delete LabelF;
	delete ButtonF1;
	delete ButtonF2;
	delete LabelAddP;
	delete EditAddP;
	delete ButtonKep;
	delete OpenDialog1;
	delete Openpic;
}

//******************************************************************************
//    CALLBACK functions
//******************************************************************************
void MainForm::OnCommand(WORD command){
	BlinkingOFF();
	REGCALLBK(ButtonX) ButtonXClick();
	REGCALLBK(ButtonF1) ButtonF1Click();
	REGCALLBK(ButtonF2) ButtonF2Click();
	REGCALLBK(ButtonH1) ButtonH1Click();
	REGCALLBK(ButtonH2) ButtonH2Click();
	REGCALLBK(ButtonKep) ButtonKepClick();
	if(command==IDM_SENDFILE){
		ReqSendFileToClient();
	}
	if(command==IDM_ANIMATE){
		SetAnimate();
	}
	if(command==IDM_REGISTER){
		SpecifyINIfile();
	}
	if(command==IDM_CALL){
		ShowMessage("Fejleszts alatt.\nSajnos ez az opci mg nem aktv :(");
	}
	if(command==IDM_VIDEO){
		ShowMessage("Fejleszts alatt.\nSajnos ez az opci mg nem aktv :(");
	}
	if(command==IDM_ABOUT){
		ShowMessage("Ksztette: Bognr Andrs 2013");
	}
}

void MainForm::OnPaint(){
	if(Canvas==NULL)
		return;
	if(InRepaint){
		return;
	}
	InRepaint=1;
  	HDC         hdc;
    PAINTSTRUCT ps;
    RECT        rect;
	int tab=TAB;
    hdc = BeginPaint (hwnd, &ps);
    if(!hdc){
#ifdef GUIERR
		MessageBox(hwnd, TEXT("ERROR: BeginPaint() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
#endif
		InRepaint=0;
		return;
	}
	//Double buffered screen refreshing
	if(Canvas->EnableRefresh)
		if(!(BitBlt(hdcDoubleBuf,Canvas->STX,Canvas->STY,Canvas->WID,Canvas->HEI,Canvas->Mhdc,0, 0, SRCCOPY))){
#ifdef GUIERR
			char n[50];
			sprintf(n,"ERROR: BitBlt() failed (1) C=%d",GetLastError());
			MessageBox(hwnd, n, "Bitmap error", MB_APPLMODAL | MB_ICONSTOP);
#endif
		}
	if(tab){
		if(!(BitBlt(hdcDoubleBuf,MBVX,MBVY,MBVW,MBVH,Mhdc,0, MainViewY, SRCCOPY))){
#ifdef GUIERR
			char n[50];
			sprintf(n,"ERROR: BitBlt() failed (2) C=%d",GetLastError());
			MessageBox(hwnd, n, "Bitmap error", MB_APPLMODAL | MB_ICONSTOP);
#endif
		}
		if(!(BitBlt(hdcDoubleBuf,EBVX,EBVY,EBVW,EBVH,MhdcSz,0, EditViewY, SRCCOPY))){
#ifdef GUIERR
			char n[50];
			sprintf(n,"ERROR: BitBlt() failed (3) C=%d",GetLastError());
			MessageBox(hwnd, n, "Bitmap error", MB_APPLMODAL | MB_ICONSTOP);
#endif
		}
	}
	//copy buffer to screen
	//check if any update happened
	if(Canvas->EnableRefresh||tab){
		if(!(BitBlt(hdc,0,0,FRW,FRH,hdcDoubleBuf,0, 0, SRCCOPY))){
#ifdef GUIERR
			char n[50];
			sprintf(n,"ERROR: BitBlt() failed (3) C=%d",GetLastError());
			MessageBox(hwnd, n, "Bitmap error", MB_APPLMODAL | MB_ICONSTOP);
#endif
		}
	}
    EndPaint (hwnd, &ps);
	InRepaint=0;
}

//300msec timer
void MainForm::OnTimer(unsigned TimerID){
	if(intimer)
		return;
	intimer=1;
	if(Timer1&&(TimerID==Timer1->ID)){
		DrawGIF();
	}
	//try to reconnect if connection lost
	if(TryReconnect){
		TryReconnect--;
		if(TryReconnect<=0){
			TryReconnect=0;
			AliveRet=0;
			if(ClientThreadRun){
				DestroyClient();
				Sleep(500);
			}
			if(CreateClient()){
				GuiPrint("Sikeres csatlakozs\n");
			}else{
				GuiPrint("Kapcsoldsi hiba\n");
			}
			AliveCnt=-60;
		}
	}
	intimer=0;
	//blinking and scheduled periodic GUI update
	if(cursorState){
		ShowEditCursor();
		cursorState=0;
	}else{
		HideEditCursor();
		cursorState=1;
	}
	if(Blinking){
		if(Blinkstate==0){
			Blink2();
		}else if(Blinkstate==5){
			Blink1();
		}
		Blinkstate++;
		if(Blinkstate>10){
			Blinkstate=0;
		}
	}
	//scheduled automatic GUI updating counter. This is for automatic GUI paint repairing
	AutGuiUpdt++;
	if(AutGuiUpdt>30){
		OnPaint();
		AutGuiUpdt=0;
	}
	//Server Alive response
	if(!TryReconnect&&AuthPassed){
		if(AliveCnt==0){
			if(AliveRet){
				//leszakadt a kapcsolat, jracsatlakozs
				NetDisconnectNotif();
				system("ipconfig /flushdns");
			}else{
				AliveRet=1;
				CAlive();
			}
		}
		AliveCnt++;
		if(AliveCnt>40)
			AliveCnt=0;
	}
}

void MainForm::OnChar(char ch){
	int x;
	inOnChar=1;
	if(ch==13){
		if(!TAB){
			//Add partner+
			AnsiString part=EditAddP->Text;
			if(!part.IsEmpty()){
				EditAddP->Text="";
				ServerReqAddPartner(part);
			}
		}else{
			//Edit window transfer
			OnMouseButton(-1,-1);
			FlushEdit();
			echar=0;
			EditM->Clear();
		}
		inOnChar=0;
		return;
	}
	//If tab=0 then no operation
	if(!TAB)
		return;
	if(ch==8){
		if((Epoi>0)&&(echar>0)){
			for(x=echar;x<Epoi;x++){
				Editbuf[x-1]=Editbuf[x];
			}
			echar--;
			Epoi--;
			ComputeVisibleCursor();
		}
		inOnChar=0;
		RECT r;
		r.left=EBVX;
		r.top=EBVY;
		r.right=EBVX+EBVW;
		r.bottom=EBVY+EBVH;
		InvalidateRect(hwnd,&r,TRUE);
		return;
	}
	if((Epoi>1000)||((unsigned char)ch<32)||((ch>126)&&(ch<160))){
		inOnChar=0;
		return;
	}
	if(echar==Epoi){
		//Add to buf
		Editbuf[Epoi++]=ch;
		//Draw out
		ClearEdit();
		SetEditFont();
		for(x=0;x<Epoi;x++)
			PutCharToEdit(Editbuf[x]);
		echar++;
		vecx=ecx;
		vecy=ecy;
	}else{
		//insert to buf
		for(x=Epoi;x>echar;x--){
			Editbuf[x]=Editbuf[x-1];
		}
		Editbuf[echar++]=ch;
		Epoi++;
		//Draw out
		ComputeVisibleCursor();
	}
	
	inOnChar=0;
}

void MainForm::OnKeyDown(WPARAM w){
	BlinkingOFF();
	int x;
	w=w&0xFF;
	switch(w){
		case VK_LEFT:
			if(echar==0)
				break;
			echar--;
			ComputeVisibleCursor();
			break;
		case VK_RIGHT:
			echar++;
			if(echar>Epoi)
				echar=Epoi;
			ComputeVisibleCursor();
			break;
		case VK_CONTROL:
			CTRLpressed=1;
			break;
		case 0x56:	//V
			if(CTRLpressed){
				CTRLpressed=0;
				CopyFromClipboard();
			}
			break;
		case VK_DELETE:
			if((Epoi>0)&&(echar<Epoi)){
				for(x=echar+1;x<Epoi;x++){
					Editbuf[x-1]=Editbuf[x];
				}
				Epoi--;
				ComputeVisibleCursor();
				RECT r;
				r.left=EBVX;
				r.top=EBVY;
				r.right=EBVX+EBVW;
				r.bottom=EBVY+EBVH;
				InvalidateRect(hwnd,&r,TRUE);
			}
			break;
		case VK_HOME:
			echar=0;
			ComputeVisibleCursor();
			break;
		case VK_END:
			echar=Epoi;
			ComputeVisibleCursor();
			break;
		case VK_TAB:
			OnChar(32);
			OnChar(32);
			OnChar(32);
			OnChar(32);
			break;
	}
}

void MainForm::OnKeyUp(WPARAM w){
	CTRLpressed=0;
}

void MainForm::SwitchToTab(int ToTAB){
	OnMouseButton(-1,-1);
	int van;
	Session* ses;
	RECT r;

	//Hide actual tab
	int tab=SendMessage(TabControl1->GRhwnd,TCM_GETCURSEL,0,0);
	if(!tab){
		HideMainPanel();
		Sleep(100);
		InvalidateRect(hwnd,NULL,TRUE);
	}else{
		ShowWindow(ButtonX->ButtonHwnd,SW_HIDE);
		van=0;
		for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
			if( ((*j)->valid) && ((*j)->tab==tab) ){
				van=1;
				ses=(*j);
				break;
			}
		}
		if(!van){
			ShowMessage("ERROR Session failure (1)");
			return;
		}
		memcpy( ses->win,DIBport,MBW*MBH*3 );
		Sleep(100);
		InvalidateRect(hwnd,NULL,TRUE);
		ses->CX=mcx;ses->CY=mcy;
	}
	
	//Show new tab
	TabControl1->SwitchToTab(ToTAB);
	tab=ToTAB;
	if(!tab){
		DrawMainPanelUp();
		ActSes=NULL;
		
		r.left=POSZ;
		r.top=PSOR;
		r.right=POSZ+200;
		r.bottom=PSORMAX+PH;
		Sleep(100);
		InvalidateRect(hwnd,&r,TRUE);
	}else{
		TScrollBar2->SetPos(0);
		ShowWindow(ButtonX->ButtonHwnd,SW_SHOW);
		van=0;
		for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
			if( ((*j)->valid) && ((*j)->tab==tab) ){
				van=1;
				ses=(*j);
				break;
			}
		}
		if(!van){
			ShowMessage("ERROR Session failure (2)");
			return;
		}
		memcpy( DIBport,ses->win,MBW*MBH*3 );
		GdiFlush();
		ActSes=ses;
		
		mcx=ses->CX;mcy=ses->CY;
		MainViewY=mcy+55-MBVH;
		if(MainViewY<0)
			MainViewY=0;
		if(MainViewY>MBH-MBVH)
			MainViewY=MBH-MBVH;
		ScrollPos=MainViewY*100/(MBH-MBVH);
		TScrollBar1->SetPos(ScrollPos);
		Sleep(100);
		InvalidateRect(hwnd,NULL,TRUE);
	}
	TAB=tab;
}

//Switch to tab in the background without changing the graphics
void MainForm::SwitchToTabHidden(int ToTAB){
	int van;
	Session* ses;

	//Hide actual tab
	int tab=TAB;
	if(tab){
		van=0;
		for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
			if( ((*j)->valid) && ((*j)->tab==tab) ){
				van=1;
				ses=(*j);
				break;
			}
		}
		if(!van){
			ShowMessage("ERROR Session failure (1)");
			return;
		}
		memcpy( ses->win,DIBport,MBW*MBH*3 );
		ses->CX=mcx;ses->CY=mcy;
	}
	
	//Show new tab
	tab=ToTAB;
	if(!tab){
		ActSes=NULL;
	}else{
		van=0;
		for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
			if( ((*j)->valid) && ((*j)->tab==tab) ){
				van=1;
				ses=(*j);
				break;
			}
		}
		if(!van){
			ShowMessage("ERROR Session failure (2)");
			return;
		}
		memcpy( DIBport,ses->win,MBW*MBH*3 );
		GdiFlush();
		ActSes=ses;
		
		mcx=ses->CX;mcy=ses->CY;
	}
	TAB=tab;
}

void MainForm::OnNotify(NMHDR*notif){
	OnMouseButton(-1,-1);
	int van;
	Session* ses;
	RECT r;
	int tab=SendMessage(TabControl1->GRhwnd,TCM_GETCURSEL,0,0);
	TAB=tab;
	if(tab==-1)
		return;
	if(notif->code==TCN_SELCHANGING){
		if(!tab){
			HideMainPanel();
			Sleep(100);
			InvalidateRect(hwnd,NULL,TRUE);
		}else{
			ShowWindow(ButtonX->ButtonHwnd,SW_HIDE);
			van=0;
			for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
				if( ((*j)->valid) && ((*j)->tab==tab) ){
					van=1;
					ses=(*j);
					break;
				}
			}
			if(!van){
				ShowMessage("ERROR Session failure (1)");
				return;
			}
			memcpy( ses->win,DIBport,MBW*MBH*3 );
			Sleep(100);
			InvalidateRect(hwnd,NULL,TRUE);
			ses->CX=mcx;ses->CY=mcy;
		}
	}else if(notif->code==TCN_SELCHANGE){
		if(!tab){
			DrawMainPanelUp();
			ActSes=NULL;
			
			r.left=POSZ;
			r.top=PSOR;
			r.right=POSZ+200;
			r.bottom=PSORMAX+PH;
			Sleep(100);
			InvalidateRect(hwnd,&r,TRUE);
		}else{
			TScrollBar2->SetPos(0);
			ShowWindow(ButtonX->ButtonHwnd,SW_SHOW);
			van=0;
			for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
				if( ((*j)->valid) && ((*j)->tab==tab) ){
					van=1;
					ses=(*j);
					break;
				}
			}
			if(!van){
				ShowMessage("ERROR Session failure (2)");
				return;
			}
			memcpy( DIBport,ses->win,MBW*MBH*3 );
			GdiFlush();
			ActSes=ses;
			
			mcx=ses->CX;mcy=ses->CY;
			MainViewY=mcy+55-MBVH;
			if(MainViewY<0)
				MainViewY=0;
			if(MainViewY>MBH-MBVH)
				MainViewY=MBH-MBVH;
			ScrollPos=MainViewY*100/(MBH-MBVH);
			TScrollBar1->SetPos(ScrollPos);
			Sleep(100);
			InvalidateRect(hwnd,NULL,TRUE);
		}
	}
}

void MainForm::Vscroll(DWORD s_info,DWORD s_handle){
	WORD cmd=LOWORD(s_info);
	WORD npos=HIWORD(s_info);
	int pos;
	//cmd:
	//0:upper button pressed
	//1:lower button pressed
	//2:upper area pressed
	//3:lower area pressed
	//4,5,6:scrollbar tick movement
	if((HANDLE)s_handle==TScrollBar1->ScrollBarHwnd){
		pos=TScrollBar1->GetPos();
		if((cmd==0)||(cmd==2)){
			pos-=8;
			if(pos<0)
				pos=0;
		}else if((cmd==1)||(cmd==3)){
			pos+=8;
			if(pos>100)
				pos=100;
		}else if((cmd==4)||(cmd==5)||(cmd==6)){
			pos=npos;
		}else
			return;
		TScrollBar1->SetPos(pos);
		ScrollPos=pos;
		if(!TAB){
			RECT r;
			r.left=POSZ;
			r.top=PSOR;
			r.right=POSZ+200;
			r.bottom=PSORMAX+PH;
			DrawMainPanel();
			InvalidateRect(hwnd,&r,TRUE);
		}else{
			MainViewY=(MBH-MBVH)*pos/100;
			RECT r;
			r.left=MBVX;
			r.top=MBVY;
			r.right=MBVX+MBVW;
			r.bottom=MBVY+MBVH;
			InvalidateRect(hwnd,&r,TRUE);
		}
	}
	if((HANDLE)s_handle==TScrollBar2->ScrollBarHwnd){
		pos=TScrollBar2->GetPos();
		if((cmd==0)||(cmd==2)){
			pos-=8;
			if(pos<0)
				pos=0;
		}else if((cmd==1)||(cmd==3)){
			pos+=8;
			if(pos>100)
				pos=100;
		}else if((cmd==4)||(cmd==5)||(cmd==6)){
			pos=npos;
		}else
			return;
		TScrollBar2->SetPos(pos);
		if(TAB){
			EditViewY=(EBH-EBVH)*pos/100;
			RECT r;
			r.left=EBVX;
			r.top=EBVY;
			r.right=EBVX+EBVW;
			r.bottom=EBVY+EBVH;
			InvalidateRect(hwnd,&r,TRUE);
		}
	}
}

void MainForm::OnMouseButton(int xPos,int yPos){
	BlinkingOFF();
	//Show up Edit box
	if(TAB&&ActSes){
		//main window -> edit box
		if( (xPos>MBVX)&&(xPos<MBVX+MBVW)&&(yPos>MBVY)&&(yPos<MBVY+MBVH) ){
			ShowWindow(EditE->MemoHwnd,SW_HIDE);
			ShowWindow(EditM->MemoHwnd,SW_SHOW);
			M_edit=1;
			
			char str[33];
			int cnt=ActSes->bpoi;
			int x=0;
			
			do{
				if((ActSes->buf[cnt]!=13)&&(ActSes->buf[cnt]!=0)){
					str[x++]=ActSes->buf[cnt];
					if(x>=32){
						str[32]=0;
						x=0;
						EditM->Add(str);
					}else if(str[x-1]==10){
						str[x-1]=0;
						x=0;
						EditM->Add(str);
					}
				}
				cnt=(cnt+1)&0x7FF;
			}while(cnt!=ActSes->bpoi);
			if(x){
				str[x]=0;
				EditM->Add(str);
			}
			return;
		}
		//edit window -> edit box
		if( (xPos>EBVX)&&(xPos<EBVX+EBVW)&&(yPos>EBVY)&&(yPos<EBVY+EBVH) ){
			ShowWindow(EditM->MemoHwnd,SW_HIDE);
			ShowWindow(EditE->MemoHwnd,SW_SHOW);
			E_edit=1;
			
			char str[32];
			int cnt=0;
			int x;
			Editbuf[1000]=0;
			while(1){
				for(x=0;x<32;x++){
					str[x]=Editbuf[cnt++];
					if(!str[x])break;
					if(x==Epoi)break;
				}
				str[x]=0;
				EditE->Add(str);
				if(!Editbuf[cnt-1])break;
				if(x==Epoi)break;
			}
			return;
		}
	}
	
	//Hiding Edit Box
	if(M_edit){
		EditM->Clear();
		ShowWindow(EditM->MemoHwnd,SW_HIDE);
		M_edit=0;
	}
	if(E_edit){
		//transfer from floating Edit box to Edit window
		ClearEdit();
		SetEditFont();
		Epoi=0;
		echar=0;
		AnsiString str;
		for(int x=0;x<EditE->Count();x++){
			str=EditE->Strings[x];
			for(int y=0;y<strlen(str.String);y++){
				PutCharToEdit(str.String[y]);
				Editbuf[Epoi++]=str.String[y];
				if(Epoi>1020)break;
			}
			if(Epoi>1020)break;
		}
		echar=Epoi;
		vecx=ecx;
		vecy=ecy;
		
		EditE->Clear();
		ShowWindow(EditE->MemoHwnd,SW_HIDE);
		E_edit=0;
	}
}

void MainForm::OnMouseDbClick(int X,int Y){
	BlinkingOFF();
	int pos;
	if(!TAB){
		if((X>=POSZ)&&(X<=POSZ+100)&&(Y>=PSOR)&&(Y<=PSORMAX)){
			for (std::vector<Partner*>::iterator i = Partners.begin(); i != Partners.end(); ++i){
				pos=(*i)->IconPos;
				if( (Y>=pos)&&(Y<=(pos+PH)) ){
					AddSession( (*i)->name.String,1 );
					break;
				}
			}
		}
	}
}

void MainForm::OnMouseWheel(int xPos,int yPos,WORD delta,WORD buttons){
	BlinkingOFF();
	int d=delta;
	if(d&0x8000){
		d|=0xFFFF0000;
	}
	ScrollPos+=-d/30;
	if(ScrollPos<0)ScrollPos=0;
	if(ScrollPos>100)ScrollPos=100;
	TScrollBar1->SetPos(ScrollPos);
	if(!TAB){
		RECT r;
		r.left=POSZ;
		r.top=PSOR;
		r.right=POSZ+200;
		r.bottom=PSORMAX+PH;
		DrawMainPanel();
		InvalidateRect(hwnd,&r,TRUE);
	}else{
		MainViewY=(MBH-MBVH)*ScrollPos/100;
		RECT r;
		r.left=MBVX;
		r.top=MBVY;
		r.right=MBVX+MBVW;
		r.bottom=MBVY+MBVH;
		InvalidateRect(hwnd,&r,TRUE);
	}
}

//POPUP menu
void MainForm::OnMouseRightBtn(int X,int Y){
	BlinkingOFF();
	if(!TAB)
		return;
	HMENU hmenu;
	HMENU hmenuTrackPopup;
	POINT pt;
	pt.x=X;
	pt.y=Y;
	ClientToScreen(hwnd, (LPPOINT) &pt);
	if ((hmenu = LoadMenu(hinst, MAKEINTRESOURCE(POPUPMENU))) == NULL) 
        return;
	hmenuTrackPopup = GetSubMenu(hmenu, 0); 
	TrackPopupMenu(hmenuTrackPopup, TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, 0, hwnd, NULL);
	DestroyMenu(hmenu);
}

//Close actual tab
void MainForm::ButtonXClick(){
	//Hiding Edit Box
	if(M_edit){
		EditM->Clear();
		ShowWindow(EditM->MemoHwnd,SW_HIDE);
		M_edit=0;
	}
	if(E_edit){
		EditE->Clear();
		ShowWindow(EditE->MemoHwnd,SW_HIDE);
		E_edit=0;
	}
	RemoveSession();
}

//Select another font
void MainForm::ButtonF1Click(){
	i->EditFont--;
	if(i->EditFont<1)i->EditFont=10;
	ChangeEditFont();
	
	if(SaveToIni(INIfile.String)){
		ShowMessage("Slyos hiba: nem lehet menteni az INI fjlba!");
	}
}

//Select another font
void MainForm::ButtonF2Click(){
	i->EditFont++;
	if(i->EditFont>10)i->EditFont=1;
	ChangeEditFont();

	if(SaveToIni(INIfile.String)){
		ShowMessage("Slyos hiba: nem lehet menteni az INI fjlba!");
	}
}

//Set another Frame <
void MainForm::ButtonH1Click(){
	i->ActFrame--;
	if(i->ActFrame<0)
		i->ActFrame=Frames.size()-1;
	SetFrame();
	
	if(SaveToIni(INIfile.String)){
		ShowMessage("Slyos hiba: nem lehet menteni az INI fjlba!");
	}
	InvalidateRect(hwnd,NULL,TRUE);
}

//Set another Frame >
void MainForm::ButtonH2Click(){
	i->ActFrame++;
	if(i->ActFrame>=Frames.size())
		i->ActFrame=0;
	SetFrame();
	
	if(SaveToIni(INIfile.String)){
		ShowMessage("Slyos hiba: nem lehet menteni az INI fjlba!");
	}
	InvalidateRect(hwnd,NULL,TRUE);
}

//Change picture
void MainForm::ButtonKepClick(){
	ServerReqChangePic();
}

//******************************************************************************
//    SERVICE functions
//******************************************************************************

void MainForm::EnterGUICritical(){
	GUIsema->WaitFor(10000);
}

void MainForm::LeaveGUICritical(){
	GUIsema->Release();
}

void MainForm::PutStrToMain(char*str){
	int x=0;
	char obj[4];
	while(str[x]){
		if(str[x]=='#'){
			if((str[x+1]>='0')&&(str[x+1]<='9')&&(str[x+2]>='0')&&(str[x+2]<='9')&&(str[x+3]>='0')&&(str[x+3]<='9')){
				obj[0]=str[x+1];
				obj[1]=str[x+2];
				obj[2]=str[x+3];
				obj[3]=0;
				PutObjectToMain(obj);
				x+=4;
				continue;
			}
		}
		PutCharToMain(str[x]);
		x++;
	}
}

void MainForm::PutCharToMain(char c){
	if(c==13)
		return;
	if(!ActSes)
		return;
	SIZE size;
	int move;
	char str[2];
	str[0]=c;
	str[1]=0;
	GetTextExtentPoint32(Mhdc,str,1,&size);
	//new line
	if((mcx+size.cx+5>MBW)||(c==10)){
		mcy+=15;
		mcx=5;
		if(extrarow){
			mcy+=45;
			extrarow=0;
		}
		//check if scroll needed
		if(mcy+20>MBH){
			move=mcy+20-MBH;
			if(!(BitBlt(Mhdc,0,0,MBW,MBH-move,Mhdc,0, move, SRCCOPY))){
#ifdef GUIERR
				MessageBox(hwnd, TEXT("ERROR: BitBlt() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
#endif
			}
			mcy-=move;
			HBRUSH hBrush = CreateSolidBrush(mColor);
			RECT r;
			r.left=0;
			r.top=MBH-move;
			r.right=MBW;
			r.bottom=MBH;
			FillRect(Mhdc,&r,hBrush);
			DeleteObject(hBrush);
			ScrollGIFs(move);
		}
	}

	//Put to actual buffer
	ActSes->buf[ActSes->bpoi++]=str[0];
	ActSes->bpoi=ActSes->bpoi&0x7FF;
	
	if(c==10)
		return;

	//Draw out
	TextOut(Mhdc,mcx,mcy,str,1);
	mcx+=size.cx;
	
	if(!SpecialGUI){
		//scroll viewport
		if( ((mcy+20)>(MainViewY+MBVH)) || (mcy<MainViewY) ){
			MainViewY=mcy+20-MBVH;
			if(MainViewY<0)
				MainViewY=0;
			if(MainViewY>MBH-MBVH)
				MainViewY=MBH-MBVH;
			ScrollPos=MainViewY*100/(MBH-MBVH);
			TScrollBar1->SetPos(ScrollPos);
		}
	}
}

void MainForm::PutObjectToMain(char* obj){
	if(!ActSes)
		return;
	int x;
	int move;
	int recycled=0;
	
	//new line
	if(mcx+55>MBW){
		mcy+=50;
		mcx=5;
		if(extrarow){
			mcy+=45;
			extrarow=0;
		}
		//check if scroll needed
		if(mcy+20>MBH){
			move=mcy+20-MBH;
			if(!(BitBlt(Mhdc,0,0,MBW,MBH-move,Mhdc,0, move, SRCCOPY))){
#ifdef GUIERR
				MessageBox(hwnd, TEXT("ERROR: BitBlt() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
#endif
			}
			mcy-=move;
			HBRUSH hBrush = CreateSolidBrush(mColor);
			RECT r;
			r.left=0;
			r.top=MBH-move;
			r.right=MBW;
			r.bottom=MBH;
			FillRect(Mhdc,&r,hBrush);
			DeleteObject(hBrush);
			ScrollGIFs(move);
		}
	}
	
	AnsiString Root=GIFRoot+obj+"\\*.*";
	
	GIF* gif;
	for (std::vector<GIF*>::iterator i = ActSes->Objlist.begin(); i != ActSes->Objlist.end(); ++i){
		if( (*i)->valid==0 ){
			gif=(*i);
			recycled=1;
			break;
		}
	}
	if(!recycled){
		gif=new GIF();
		for(x=0;x<50;x++)
			gif->kep[x]=NULL;
	}
		
	gif->x=mcx;
	gif->y=mcy;
	gif->phnum=0;
	gif->phact=0;
	gif->valid=1;
	strcpy(gif->name,obj);
	
	//Fill in PATH table
	HANDLE HFind;
	WIN32_FIND_DATA FindFileData;
	
	HFind=FindFirstFile(Root.String,&FindFileData);
	if(HFind == INVALID_HANDLE_VALUE){
		PutCharToMain('#');PutStrToMain(obj);
		return;
	}else{
		if(!(FindFileData.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)){
			if(gif->kep[gif->phnum]==NULL)gif->kep[gif->phnum]=new AnsiString();
			if(IsBMPfile(FindFileData.cFileName)){
				strcpy(gif->kep[gif->phnum]->String,FindFileData.cFileName);
				gif->phnum++;
			}
		}
	}
	while(FindNextFile(HFind,&FindFileData)){
		if(!(FindFileData.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)){
			if(gif->kep[gif->phnum]==NULL)gif->kep[gif->phnum]=new AnsiString();
			if(IsBMPfile(FindFileData.cFileName)){
				strcpy(gif->kep[gif->phnum]->String,FindFileData.cFileName);
				gif->phnum++;
			}
		}
	}
	FindClose(HFind);
	
	//Put GIF place
	HBRUSH hBrush = CreateSolidBrush(RGB( 0,0,0 ) );
	RECT r;
	r.left=gif->x;
	r.top=gif->y;
	r.right=gif->x+30;
	r.bottom=gif->y+30;
    FillRect(Mhdc,&r,hBrush);
	DeleteObject(hBrush);
	
	//Add GIF to list
	if(!recycled)
		ActSes->Objlist.push_back(gif);
	
	//move cursor
	mcx+=50;
	extrarow=1;
	
	if(!SpecialGUI){
		//scroll viewport
		if( ((mcy+50)>(MainViewY+MBVH)) || (mcy<MainViewY) ){
			MainViewY=mcy+55-MBVH;
			if(MainViewY<0)
				MainViewY=0;
			if(MainViewY>MBH-MBVH)
				MainViewY=MBH-MBVH;
			ScrollPos=MainViewY*100/(MBH-MBVH);
			TScrollBar1->SetPos(ScrollPos);
		}
	}
}

int MainForm::IsBMPfile(char* fname){
	int len=strlen(fname);
	if( ((fname[len-3]=='b')||(fname[len-3]=='B')) && ((fname[len-2]=='m')||(fname[len-2]=='M')) && ((fname[len-1]=='p')||(fname[len-1]=='P')) )
		return 1;
	else
		return 0;
}

void MainForm::PutCharToEdit(char c){
	RECT r;
	if(c==13)
		return;
	//HideEditCursor();
	SIZE size;
	int move;
	char str[2];
	str[0]=c;
	str[1]=0;
	GetTextExtentPoint32(MhdcSz,str,1,&size);
	//new line
	if((ecx+size.cx+5>EBW)||(c==10)){
		ecy+=15;
		ecx=5;
		if(extrarow){
			ecy+=45;
			extrarow=0;
		}
		//check if scroll needed
		if(ecy+20>EBH){
			move=ecy+20-EBH;
			if(!(BitBlt(MhdcSz,0,0,EBW,EBH-move,MhdcSz,0, move, SRCCOPY))){
#ifdef GUIERR
				MessageBox(hwnd, TEXT("ERROR: BitBlt() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
#endif
			}
			ecy-=move;
			HBRUSH hBrush = CreateSolidBrush(eColor);
			r.left=0;
			r.top=EBH-move;
			r.right=EBW;
			r.bottom=EBH;
			FillRect(MhdcSz,&r,hBrush);
			DeleteObject(hBrush);
		}
	}
	
	if(c==10)
		return;

	TextOut(MhdcSz,ecx,ecy,str,1);
	ecx+=size.cx;
	
	//scroll viewport
	if( ((ecy+20)>(EditViewY+EBVH)) || (ecy<EditViewY) ){
		EditViewY=ecy+20-EBVH;
		if(EditViewY<0)
			EditViewY=0;
		if(EditViewY>EBH-EBVH)
			EditViewY=EBH-EBVH;
		ScrollPos=EditViewY*100/(EBH-EBVH);
		TScrollBar2->SetPos(ScrollPos);
	}
	
	//redraw
	r.left=EBVX;
	r.top=EBVY;
	r.right=EBVX+EBVW;
	r.bottom=EBVY+EBVH;
	InvalidateRect(hwnd,&r,TRUE);
}

void MainForm::DrawGIF(){
	if(!ActSes)
		return;
	if(!TAB)
		return;
	AnsiString fn;
	GIF*gif;
	HBITMAP MhbmpLOC;
	BITMAP bm;
	HDC hdc;
	HDC MhdcLOC;
	RECT r;
	for (std::vector<GIF*>::iterator i = ActSes->Objlist.begin(); i != ActSes->Objlist.end(); ++i){
		gif=(*i);
		if((gif==NULL)||(gif->y<0)||(gif->valid==0))
			continue;
		//is in viewport?
		if( ((gif->y+50)<MainViewY) || (gif->y>(MainViewY+MBVH)) )
			continue;
		
		fn=*(gif->kep[gif->phact]);
		fn=GIFRoot+gif->name+"\\"+fn;
	
		//Print BMP GIF file
		hdc=GetDC(hwnd);
		if(!hdc){
#ifdef GUIERR
			MessageBox(hwnd, TEXT("ERROR: GetDC() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
#endif
			return;
		}
		MhbmpLOC=(HBITMAP)LoadImage(NULL,fn.String,IMAGE_BITMAP,0,0,LR_LOADFROMFILE);
		if(!MhbmpLOC){
#ifdef GUIERR
			MessageBox(hwnd, TEXT("ERROR: LoadImage() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
#endif
			return;
		}
		MhdcLOC=CreateCompatibleDC(hdc);
		if(!MhdcLOC){
#ifdef GUIERR
			MessageBox(hwnd, TEXT("ERROR: CreateCompatibleDC() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
#endif
			return;
		}
		SelectObject ( MhdcLOC, MhbmpLOC );
		GetObject ( MhbmpLOC, sizeof(bm), &bm );
		if(!(BitBlt(Mhdc,gif->x,gif->y,bm.bmWidth,bm.bmHeight,MhdcLOC,0, 0, SRCCOPY))){
#ifdef GUIERR
			MessageBox(hwnd, TEXT("ERROR: BitBlt() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
#endif
			return;
		}
		
		r.left=gif->x+MBVX;
		r.top=gif->y+MBVY-MainViewY;
		r.right=gif->x+bm.bmWidth+MBVX;
		r.bottom=gif->y+bm.bmHeight+MBVY-MainViewY;
		InvalidateRect(hwnd,&r,TRUE);
		DeleteObject(MhbmpLOC);
		ReleaseDC(hwnd,hdc);
		DeleteDC(MhdcLOC);

		gif->phact++;
		if((gif->phact)>=(gif->phnum))
			gif->phact=0;
	}
}

//Scrolling GIFs in the main window
void MainForm::ScrollGIFs(int move){
	if(!ActSes)
		return;
	if(intimer){
		Sleep(50);
		if(intimer)Sleep(100);
		if(intimer)Sleep(100);
		if(intimer)Sleep(100);
	}
	intimer=1;
	GIF*gif;
	AnsiString* str;
	for (std::vector<GIF*>::iterator i = ActSes->Objlist.begin(); i != ActSes->Objlist.end(); ++i){
		gif=(*i);
		if(gif->valid==0)
			continue;
		gif->y-=move;
		if(gif->y<0){
			gif->valid=0;
		}
	}
	
	if(!SpecialGUI){
		RECT r;
		r.left=MBVX;
		r.top=MBVY;
		r.right=MBVX+MBVW;
		r.bottom=MBVY+MBVH;
		InvalidateRect(hwnd,NULL,TRUE);
		intimer=0;
	}
}

//Transfer characters from EDIT to MAIN window <ENTER>
void MainForm::FlushEdit(){
	if(!Epoi)
		return;
	
	EnterGUICritical();
	
	Editbuf[Epoi]=0;
	SetMainFont(i->EditFont);
	ChangeToAnim();
	PutStrToMain(Editbuf);
	
	if(!AdminRequest(Editbuf))
		SendScrMsgToServer(Editbuf);
	
	PutCharToMain(10);
	Epoi=0;
	
	ClearEdit();
	Sleep(100);
	InvalidateRect(hwnd,NULL,TRUE);
	
	LeaveGUICritical();
}

void MainForm::ClearEdit(){
	ecx=5;ecy=5;
	vecx=5;vecy=5;
	HBRUSH hBrush = CreateSolidBrush(eColor);
	RECT r;
	r.left=0;
	r.top=0;
	r.right=EBW;
	r.bottom=EBH;
	FillRect(MhdcSz,&r,hBrush);
    DeleteObject(hBrush);
}

void MainForm::ShowEditCursor(){
	if(inOnChar)
		return;
	HBRUSH hBrush = CreateSolidBrush(RGB( 0,0,0 ) );
	RECT r;
	r.left=vecx;
	r.top=vecy;
	r.right=vecx+1;
	r.bottom=vecy+15;
	FillRect(MhdcSz,&r,hBrush);
    DeleteObject(hBrush);
	r.left=EBVX+vecx;
	r.top=EBVY+vecy-EditViewY;
	r.right=EBVX+vecx+1;
	r.bottom=EBVY+vecy+15-EditViewY;
	InvalidateRect(hwnd,&r,TRUE);
}

void MainForm::HideEditCursor(){
	if(inOnChar)
		return;
	HBRUSH hBrush = CreateSolidBrush(eColor);
	RECT r;
	r.left=vecx;
	r.top=vecy;
	r.right=vecx+1;
	r.bottom=vecy+15;
	FillRect(MhdcSz,&r,hBrush);
    DeleteObject(hBrush);
	r.left=EBVX+vecx;
	r.top=EBVY+vecy-EditViewY;
	r.right=EBVX+vecx+1;
	r.bottom=EBVY+vecy+15-EditViewY;
	InvalidateRect(hwnd,&r,TRUE);
}

//Compute vecx, vecy from echar
void MainForm::ComputeVisibleCursor(){
	int x;
	ClearEdit();
	SetEditFont();
	for(x=0;x<echar;x++)
		PutCharToEdit(Editbuf[x]);
	vecx=ecx;
	vecy=ecy;
	for(x=echar;x<Epoi;x++){
		PutCharToEdit(Editbuf[x]);
	}
}

void MainForm::CopyFromClipboard(){
	if (!IsClipboardFormatAvailable(CF_TEXT)) 
		return;
	if (!OpenClipboard(hwnd)) 
		return;

	int x;
	LPTSTR  lptstr;
	HGLOBAL	hglb = GetClipboardData(CF_TEXT);
	if (hglb != NULL) {
		lptstr = (TCHAR*)GlobalLock(hglb);
		if (lptstr != NULL){
			for(x=0;(x<strlen(lptstr))&&(x<1000);x++){
				if((unsigned char)lptstr[x]>=32)
					OnChar(lptstr[x]);
				else
					OnChar(' ');
			}
			GlobalUnlock(hglb); 
		} 
	} 
	CloseClipboard(); 
}

void MainForm::SetFrame(){
	if(Frames.empty()){
		return;
	}
	if(i->ActFrame>=Frames.size())
		return;
	AnsiString pstr=*Frames[i->ActFrame];
	Canvas->LoadFromFile(FrameRoot+pstr);
	DrawMainPanelUp();
	ShowSetFont();
}

//Create new Session
void MainForm::AddSession(char* name,int DRAW){
	Partner* p=NULL;
	for (std::vector<Partner*>::iterator i = Partners.begin(); i != Partners.end(); ++i){
		if( !strcmp((*i)->name.String,name) ){
			p=(*i);
			if(p->ses){
				HideMainPanel();
				TAB=p->ses->tab;
				TabControl1->SwitchToTab(TAB);
				ShowWindow(ButtonX->ButtonHwnd,SW_SHOW);
				memcpy( DIBport,p->ses->win,MBW*MBH*3 );
				GdiFlush();
				ActSes=p->ses;
				Sleep(100);
				InvalidateRect(hwnd,NULL,TRUE);
				mcx=p->ses->CX;mcy=p->ses->CY;
				return;
			}
			break;
		}
	}
	if(p==NULL)
		return;
	
	AddSession(p,DRAW);
}

void MainForm::AddSession(Partner* p,int DRAW){
	if(p==NULL)
		return;
	int cnt=0;
	for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
		if((*j)->valid)cnt++;
	}
	if(cnt>=MAXSESS){
		ShowMessage("Tl sok csetablakot nyitottl meg\nZrj be egyet az j megnyitsa eltt!");
		return;
	}
	
	Session*s=NULL;
	for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
		if((*j)->valid==0){
			s=(*j);
			break;
		}
	}
	
	int r=mColor&0xFF;
	int g=(mColor&0xFF00)>>8;
	int b=(mColor&0xFF0000)>>16;
	long poi=0;
	if(s==NULL){
		s=new Session();
		s->win=new unsigned char[MBW*MBH*3];
		for(int y=0;y<MBH;y++)
			for(int x=0;x<MBW;x++){
				s->win[poi++]=b;
				s->win[poi++]=g;
				s->win[poi++]=r;
			}
		s->buf=new char[2048];
		memset( s->buf, 0, 2048 );
		s->bpoi=0;
		s->tab=TabControl1->TabCnt;
		s->part=p;
		p->ses=s;
		s->valid=1;
		s->CX=5;s->CY=5;
		s->scnt=0;
		s->blink=0;
		s->rscnt=0;
		Sessions.push_back(s);
	}else{
		for(int y=0;y<MBH;y++)
			for(int x=0;x<MBW;x++){
				s->win[poi++]=b;
				s->win[poi++]=g;
				s->win[poi++]=r;
			}
		memset( s->buf, 0, 2048 );
		s->bpoi=0;
		s->tab=TabControl1->TabCnt;
		s->part=p;
		p->ses=s;
		s->valid=1;
		s->CX=5;s->CY=5;
		s->scnt=0;
		s->blink=0;
		s->rscnt=0;
	}
	int newtab=TabControl1->AddTab(p->name.String);
	
	//Renumber and rename TABs
	cnt=1;
	for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
		if( (*j)->valid ){
			if((*j)->part)
				TabControl1->SetTab(cnt,(*j)->part->name.String);
			(*j)->tab=cnt++;
		}
	}
	
	//Show TAB
	if(DRAW){
		/*
		HideMainPanel();
		TAB=newtab;
		TabControl1->SwitchToTab(TAB);
		memcpy( DIBport,s->win,MBW*MBH*3 );
		GdiFlush();
		ActSes=s;
		Sleep(100);
		InvalidateRect(hwnd,NULL,TRUE);
		*/
		SwitchToTab(newtab);
		mcx=s->CX;mcy=s->CY;
	}
	//TabControl1->SwitchToTab(newtab);
	ShowWindow(ButtonX->ButtonHwnd,SW_SHOW);
}

//6 window is allowed temporarly for system messages.
void MainForm::AddSessionSpec(Partner* p,int DRAW){
	MAXSESS++;
	AddSession(p,DRAW);
	MAXSESS--;
}

//remove session
void MainForm::RemoveSession(){
	TAB=SendMessage(TabControl1->GRhwnd,TCM_GETCURSEL,0,0);
	if(TAB==0)
		return;
	Session*ses=NULL;
	for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
		if( ((*j)->valid) && ((*j)->tab==TAB) ){
			ses=(*j);
			break;
		}
	}
	if(!ses){
		return;
	}

	//Invalidate current TAB/session
	ActSes=ses;
	TabControl1->DeleteTab(TAB);
	TabControl1->SwitchToTab(0);
	ActSes->valid=0;
	ActSes->tab=-1;
	ActSes->part=NULL;
	ActSes->CX=0;
	ActSes->CY=0;
	ActSes->Objlist.clear();
	for (std::vector<Partner*>::iterator i = Partners.begin(); i != Partners.end(); ++i){
		if( (*i)->ses == ActSes ){
			(*i)->ses=NULL;
		}
	}
	
	//Renumber and rename TABs
	int cnt=1;
	for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
		if( (*j)->valid ){
			if((*j)->part)
				TabControl1->SetTab(cnt,(*j)->part->name.String);
			(*j)->tab=cnt++;
		}
	}
	
	//Switch to Main panel
	TAB=0;
	ActSes=NULL;
	Sleep(50);
	DrawMainPanelUp();
	ShowWindow(ButtonX->ButtonHwnd,SW_HIDE);
	Sleep(100);
	InvalidateRect(hwnd,NULL,TRUE);
	Sleep(50);
}

//resync all opened session after successful reconnection
void MainForm::ResyncAllSession(){
	for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
		if( ((*j)->valid) && (*j)->part && (*j)->part->online ){
			(*j)->blink=0;
			(*j)->scnt=0;
			(*j)->rscnt=0;
			CRouteCmdKey((*j)->part->ID, (*j)->part->cskey);
		}
	}
}

//Create new Partner
Partner* MainForm::AddPartner(int id,char* pname,int active){
	Partner* p=new Partner();
	p->ID=id;
	p->name=pname;
	p->pic=NULL;
	p->online=active;
	p->ses=NULL;
	p->IconPos=-1;
	p->cskey=0;			//send key
	p->crkey=0;			//receive key
	Partners.push_back(p);
	return p;
}

Partner* MainForm::GetPartner(int id){
	for (std::vector<Partner*>::iterator i = Partners.begin(); i != Partners.end(); ++i){
		if( (*i)->ID == id ){
			return (*i);
		}
	}
	return NULL;
}

Partner* MainForm::GetPartner(char* Name){
	for (std::vector<Partner*>::iterator i = Partners.begin(); i != Partners.end(); ++i){
		if( !strcmp( (*i)->name.String,Name ) ){
			return (*i);
		}
	}
	return NULL;
}

//Draw main panel with partners
void MainForm::DrawMainPanel(){
	ShowWindow(TScrollBar1->ScrollBarHwnd,SW_SHOW);
	ShowWindow(TScrollBar2->ScrollBarHwnd,SW_HIDE);
	
	ShowWindow(LabelH->LabelHwnd,SW_SHOW);
	ShowWindow(ButtonH1->ButtonHwnd,SW_SHOW);
	ShowWindow(ButtonH2->ButtonHwnd,SW_SHOW);
	ShowWindow(LabelF->LabelHwnd,SW_SHOW);
	ShowWindow(ButtonF1->ButtonHwnd,SW_SHOW);
	ShowWindow(ButtonF2->ButtonHwnd,SW_SHOW);
	ShowWindow(LabelAddP->LabelHwnd,SW_SHOW);
	ShowWindow(EditAddP->EditBoxHwnd,SW_SHOW);
	ShowWindow(ButtonKep->ButtonHwnd,SW_SHOW);
	
	TabControl1->SwitchToTab(0);
	//Draw partners
	HBRUSH hBrush = CreateSolidBrush(0);
	RECT r;
	r.left=POSZ;
	r.top=PSOR;
	r.right=POSZ+200;
	r.bottom=PSORMAX;
    FillRect(Canvas->Mhdc,&r,hBrush);
	DeleteObject(hBrush);
	
	int sor;
	int hx;
	if(Partners.size()<=5){
		sor=PSOR;
	}else{
		hx=Partners.size()*55-(PSORMAX-PSOR);
		sor=PSOR-hx*ScrollPos/100;
	}
	for (std::vector<Partner*>::iterator i = Partners.begin(); i != Partners.end(); ++i){
		if((*i)->online){
			DrawPartnerIcon(*i,sor);
			sor+=55;
		}
	}
	for (std::vector<Partner*>::iterator i = Partners.begin(); i != Partners.end(); ++i){
		if(!(*i)->online){
			DrawPartnerIcon(*i,sor);
			sor+=55;
		}
	}
}

void MainForm::DrawMainPanelUp(){
	ScrollPos=0;
	TScrollBar1->SetPos(0);
	DrawMainPanel();
}

void MainForm::DrawPartnerIcon(Partner*p,int sor){
	if(sor<=(PSOR-PH))
		return;
	if(sor>=PSORMAX)
		return;
	p->IconPos=sor+10;
	memcpy(DIBportClip,(p->pic)?(p->pic):DefPartnerPic,DefPartnerPicSize);
	GdiFlush();
	
	if((sor>=PSOR)&&(sor+PH<=PSORMAX)){
		if(!(BitBlt(Canvas->Mhdc,POSZ,sor,PW,PH,MhdcClip,0, 0, SRCCOPY))){
#ifdef GUIERR
			MessageBox(hwnd, TEXT("ERROR: BitBlt() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
#endif
		}
		
		SelectObject(Canvas->Mhdc, NameF);
		SetBkColor(Canvas->Mhdc, 0x000000);
		SetTextColor(Canvas->Mhdc, 0xFFFFFF);
		TextOut(Canvas->Mhdc,POSZ+PW+5,sor,p->name.String,strlen(p->name.String));
		
		SelectObject(Canvas->Mhdc, SysFont);
		if(p->online){
			SetTextColor(Canvas->Mhdc, 0x00FF00);
			TextOut(Canvas->Mhdc,POSZ+PW+5,sor+20,"online",6);
		}else{
			SetTextColor(Canvas->Mhdc, 0xAAAAAA);
			TextOut(Canvas->Mhdc,POSZ+PW+5,sor+20,"offline",7);
		}
	}else if(sor+PH>PSORMAX){
		if(!(BitBlt(Canvas->Mhdc,POSZ,sor,PW,PSORMAX-sor,MhdcClip,0, 0, SRCCOPY))){
#ifdef GUIERR
			MessageBox(hwnd, TEXT("ERROR: BitBlt() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
#endif
		}
	}else{
		if(!(BitBlt(Canvas->Mhdc,POSZ,PSOR,PW,PH-(PSOR-sor),MhdcClip,0, PSOR-sor, SRCCOPY))){
#ifdef GUIERR
			MessageBox(hwnd, TEXT("ERROR: BitBlt() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
#endif
		}
	}
}

void MainForm::HideMainPanel(){
	//ShowWindow(TScrollBar1->ScrollBarHwnd,SW_HIDE);
	ShowWindow(TScrollBar2->ScrollBarHwnd,SW_SHOW);
	
	ShowWindow(LabelH->LabelHwnd,SW_HIDE);
	ShowWindow(ButtonH1->ButtonHwnd,SW_HIDE);
	ShowWindow(ButtonH2->ButtonHwnd,SW_HIDE);
	ShowWindow(LabelF->LabelHwnd,SW_HIDE);
	ShowWindow(ButtonF1->ButtonHwnd,SW_HIDE);
	ShowWindow(ButtonF2->ButtonHwnd,SW_HIDE);
	ShowWindow(LabelAddP->LabelHwnd,SW_HIDE);
	ShowWindow(EditAddP->EditBoxHwnd,SW_HIDE);
	ShowWindow(ButtonKep->ButtonHwnd,SW_HIDE);
}

BYTE* MainForm::ConvertRGBToBMPBuffer ( BYTE* Buffer, int width, int height, long* newsize ){
	if ( ( NULL == Buffer ) || ( width == 0 ) || ( height == 0 ) )
		return NULL;
	int padding = 0;
	int scanlinebytes = width * 3;
	while ( ( scanlinebytes + padding ) % 4 != 0 )
		padding++;
	int psw = scanlinebytes + padding;
	*newsize = height * psw;
	BYTE* newbuf = new BYTE[*newsize];
	memset ( newbuf, 0, *newsize );
	long bufpos = 0;   
	long newpos = 0;
	for ( int y = 0; y < height; y++ )
		for ( int x = 0; x < 3 * width; x+=3 ){
			bufpos = y * 3 * width + x;
			newpos = ( height - y - 1 ) * psw + x;

			newbuf[newpos] = Buffer[bufpos+2];
			newbuf[newpos + 1] = Buffer[bufpos + 1];
			newbuf[newpos + 2] = Buffer[bufpos];
		}
	return newbuf;
}

BYTE* MainForm::ConvertBMPToRGBBuffer ( BYTE* Buffer, int width, int height ){
	if ( ( NULL == Buffer ) || ( width == 0 ) || ( height == 0 ) )
		return NULL;
	int padding = 0;
	int scanlinebytes = width * 3;
	while ( ( scanlinebytes + padding ) % 4 != 0 )     // DWORD = 4 bytes
		padding++;
	int psw = scanlinebytes + padding;
	BYTE* newbuf = new BYTE[width*height*3];
	long bufpos = 0;   
	long newpos = 0;
	for ( int y = 0; y < height; y++ )
		for ( int x = 0; x < 3 * width; x+=3 ){
			newpos = y * 3 * width + x;     
			bufpos = ( height - y - 1 ) * psw + x;

			newbuf[newpos] = Buffer[bufpos + 2];       
			newbuf[newpos + 1] = Buffer[bufpos+1]; 
			newbuf[newpos + 2] = Buffer[bufpos];     
		}
	return newbuf;
}

//Choose another font for Edit Window
//-1: error font
//0:  system font
//1-10: normal fonts
void MainForm::SetEditFont(){
	if(i==NULL)
		return;
	switch(i->EditFont){
		case -1:
			if(!ErrorFont)return;
			SelectObject(MhdcSz, ErrorFont);
			SetBkColor(MhdcSz, 0xFFFFFF);
			SetTextColor(MhdcSz, 0x0000FF);
			break;
		case 0:
			if(!SysFont)return;
			SelectObject(MhdcSz, SysFont);
			SetBkColor(MhdcSz, 0xFFF0F0);
			SetTextColor(MhdcSz, 0x000000);
			break;
		case 1:
			if(!mFont1)return;
			SelectObject(MhdcSz, mFont1);
			mColor=0xFFFFFF;
			SetBkColor(MhdcSz, mColor);
			SetTextColor(MhdcSz, 0xFF0000);
			//Canvas
			SelectObject(Canvas->Mhdc, mFont1);
			SetBkColor(Canvas->Mhdc, mColor);
			SetTextColor(Canvas->Mhdc, 0xFF0000);
			break;
		case 2:
			if(!mFont2)return;
			SelectObject(MhdcSz, mFont2);
			mColor=0x0F0FFF;
			SetBkColor(MhdcSz, mColor);
			SetTextColor(MhdcSz, 0x00FF00);
			//Canvas
			SelectObject(Canvas->Mhdc, mFont2);
			SetBkColor(Canvas->Mhdc, mColor);
			SetTextColor(Canvas->Mhdc, 0x00FF00);
			break;
		case 3:
			if(!mFont3)return;
			SelectObject(MhdcSz, mFont3);
			mColor=0x0F00F0;
			SetBkColor(MhdcSz, mColor);
			SetTextColor(MhdcSz, 0x00FFFF);
			//Canvas
			SelectObject(Canvas->Mhdc, mFont3);
			SetBkColor(Canvas->Mhdc, mColor);
			SetTextColor(Canvas->Mhdc, 0x00FFFF);
			break;
		case 4:
			if(!mFont4)return;
			SelectObject(MhdcSz, mFont4);
			mColor=0xFF00FF;
			SetBkColor(MhdcSz, mColor);
			SetTextColor(MhdcSz, 0x800080);
			//Canvas
			SelectObject(Canvas->Mhdc, mFont4);
			SetBkColor(Canvas->Mhdc, mColor);
			SetTextColor(Canvas->Mhdc, 0x800080);
			break;
		case 5:
			if(!mFont5)return;
			SelectObject(MhdcSz, mFont5);
			mColor=0x000F00;
			SetBkColor(MhdcSz, mColor);
			SetTextColor(MhdcSz, 0xF0F000);
			//Canvas
			SelectObject(Canvas->Mhdc, mFont5);
			SetBkColor(Canvas->Mhdc, mColor);
			SetTextColor(Canvas->Mhdc, 0xF0F000);
			break;
		case 6:
			if(!mFont6)return;
			SelectObject(MhdcSz, mFont6);
			mColor=0xF0F000;
			SetBkColor(MhdcSz, mColor);
			SetTextColor(MhdcSz, 0x0F00FF);
			//Canvas
			SelectObject(Canvas->Mhdc, mFont6);
			SetBkColor(Canvas->Mhdc, mColor);
			SetTextColor(Canvas->Mhdc, 0x0F00FF);
			break;
		case 7:
			if(!mFont7)return;
			SelectObject(MhdcSz, mFont7);
			mColor=0x0000FF;
			SetBkColor(MhdcSz, mColor);
			SetTextColor(MhdcSz, 0xF0F000);
			//Canvas
			SelectObject(Canvas->Mhdc, mFont7);
			SetBkColor(Canvas->Mhdc, mColor);
			SetTextColor(Canvas->Mhdc, 0xF0F000);
			break;
		case 8:
			if(!mFont8)return;
			SelectObject(MhdcSz, mFont8);
			mColor=0xF00F0F;
			SetBkColor(MhdcSz, mColor);
			SetTextColor(MhdcSz, 0xF0F0FF);
			//Canvas
			SelectObject(Canvas->Mhdc, mFont8);
			SetBkColor(Canvas->Mhdc, mColor);
			SetTextColor(Canvas->Mhdc, 0xF0F0FF);
			break;
		case 9:
			if(!mFont9)return;
			SelectObject(MhdcSz, mFont9);
			mColor=0x000FF0;
			SetBkColor(MhdcSz, mColor);
			SetTextColor(MhdcSz, 0xA0B567);
			//Canvas
			SelectObject(Canvas->Mhdc, mFont9);
			SetBkColor(Canvas->Mhdc, mColor);
			SetTextColor(Canvas->Mhdc, 0xA0B567);
			break;
		case 10:
			if(!mFont10)return;
			SelectObject(MhdcSz, mFont10);
			mColor=0x10000F;
			SetBkColor(MhdcSz, mColor);
			SetTextColor(MhdcSz, 0xF1F345);
			//Canvas
			SelectObject(Canvas->Mhdc, mFont10);
			SetBkColor(Canvas->Mhdc, mColor);
			SetTextColor(Canvas->Mhdc, 0xF1F345);
			break;
		default:
			return;
	}
}

void MainForm::ChangeEditFont(){
	ShowSetFont();
	//change background color in all session
	int r=mColor&0xFF;
	int g=(mColor&0xFF00)>>8;
	int b=(mColor&0xFF0000)>>16;
	int x;
	for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
		for(x=0;x<MBH*MBW*3-(*j)->CY*MBW*3;x+=3){
			(*j)->win[x]=b;
			(*j)->win[x+1]=g;
			(*j)->win[x+2]=r;
		}
	}
}

void MainForm::ShowSetFont(){
	//change Font display on main screen
	SetEditFont();
	char str[6]="Hello";
	RECT R;
	R.left=130;
	R.top=405;
	R.right=180;
	R.bottom=420;
	HBRUSH hBrush = CreateSolidBrush(0);
    FillRect(Canvas->Mhdc,&R,hBrush);
	DeleteObject(hBrush);
	TextOut(Canvas->Mhdc,132,405,str,5);
	R.left=130;
	R.top=405;
	R.right=200;
	R.bottom=450;
	Sleep(100);
	InvalidateRect(hwnd,&R,TRUE);
}

//Choose another font for Main Window
//-1: error font
//0:  system font
//1-10: normal fonts
void MainForm::SetMainFont(int f){
	switch(f){
		case -1:
			if(!ErrorFont)return;
			SelectObject(Mhdc, ErrorFont);
			SetBkColor(Mhdc, 0xFFFFFF);
			SetTextColor(Mhdc, 0x0000FF);
			break;
		case 0:
			if(!SysFont)return;
			SelectObject(Mhdc, SysFont);
			SetBkColor(Mhdc, 0xFFF0F0);
			SetTextColor(Mhdc, 0x000000);
			break;
		case 1:
			if(!mFont1)return;
			SelectObject(Mhdc, mFont1);
			SetBkColor(Mhdc, 0xFFFFFF);
			SetTextColor(Mhdc, 0xFF0000);
			break;
		case 2:
			if(!mFont2)return;
			SelectObject(Mhdc, mFont2);
			SetBkColor(Mhdc, 0x0F0FFF);
			SetTextColor(Mhdc, 0x00FF00);
			break;
		case 3:
			if(!mFont3)return;
			SelectObject(Mhdc, mFont3);
			SetBkColor(Mhdc, 0x0F00F0);
			SetTextColor(Mhdc, 0x00FFFF);
			break;
		case 4:
			if(!mFont4)return;
			SelectObject(Mhdc, mFont4);
			SetBkColor(Mhdc, 0xFF00FF);
			SetTextColor(Mhdc, 0x800080);
			break;
		case 5:
			if(!mFont5)return;
			SelectObject(Mhdc, mFont5);
			SetBkColor(Mhdc, 0x000F00);
			SetTextColor(Mhdc, 0xF0F000);
			break;
		case 6:
			if(!mFont6)return;
			SelectObject(Mhdc, mFont6);
			SetBkColor(Mhdc, 0xF0F000);
			SetTextColor(Mhdc, 0x0F00FF);
			break;
		case 7:
			if(!mFont7)return;
			SelectObject(Mhdc, mFont7);
			SetBkColor(Mhdc, 0x0000FF);
			SetTextColor(Mhdc, 0xF0F000);
			break;
		case 8:
			if(!mFont8)return;
			SelectObject(Mhdc, mFont8);
			SetBkColor(Mhdc, 0xF00F0F);
			SetTextColor(Mhdc, 0xF0F0FF);
			break;
		case 9:
			if(!mFont9)return;
			SelectObject(Mhdc, mFont9);
			SetBkColor(Mhdc, 0x000FF0);
			SetTextColor(Mhdc, 0xA0B567);
			break;
		case 10:
			if(!mFont10)return;
			SelectObject(Mhdc, mFont10);
			SetBkColor(Mhdc, 0x10000F);
			SetTextColor(Mhdc, 0xF1F345);
			break;
		default:
			return;
	}
}

//BLINKING
void MainForm::BlinkingTab(Session*ses){
	ses->blink=1;
	Blinking=1;
}
//Switch off Blinking
void MainForm::BlinkingOFF(){
	if(Blinking==0)
		return;
	Blinking=0;
	Blink1();
	for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
		(*j)->blink=0;
	}
	Blinkstate=0;
}
//Blink state normal
void MainForm::Blink1(){
	Title("BA Messenger");
	for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
		if( ((*j)->valid) && ((*j)->blink) ){
			if((*j)->part)
				TabControl1->SetTab((*j)->tab,(*j)->part->name.String);
		}
	}
}
//Blink state signaled
void MainForm::Blink2(){
	Title("--ZENET--");
	for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
		if( ((*j)->valid) && ((*j)->blink) ){
			if((*j)->part)
				TabControl1->SetTab((*j)->tab,"-ZI-");
		}
	}
}

int MainForm::SpecifyINIfile(){
	OpenDialog1->Filter="Regisztrcis fjl (*.ini)\0BAchat.ini";
	AnsiString FILENAME;
	AnsiString NAME;
	if(OpenDialog1->Execute()){
		FILENAME=OpenDialog1->FileName;
		NAME=ExtractFileName(FILENAME);
		if(NAME.AnsiCompare("BAchat.ini")){
			ShowMessage("rvnytelen regisztrcis fjl.\nCsak BAchat.ini nev elfogadhat!");
			return 0;
		}
		INIfile=ExtractFilePath(Application->ExeName)+"BAchat.ini";
		if(!CopyFile(FILENAME.String,INIfile.String,false)){
			ShowMessage("Hiba a msolskor.\nBAchat.ini fjlt nem sikerlt a helyre msolni.");
			return 0;
		}
		return 1;
	}else{
		return 0;
	}
}

//******************************************************************************
//    INTERFACE to network ( Client ancestor)
//******************************************************************************
void MainForm::GuiPrint(char* message){
	Partner*p=GetPartner("System");
	if(p==NULL)
		p=AddPartner(0,"System",1);
	if(p->ses==NULL)
		AddSessionSpec(p,1);
	if(p->ses==NULL)
		return;
	SwitchToTab(p->ses->tab);
	SetMainFont(-1);
	PutStrToMain(message);
	BlinkingTab(p->ses);
	Sleep(100);
	InvalidateRect(hwnd,NULL,TRUE);
}

//process partner info loaded from server
void MainForm::ProcessPartner(char*uname, int id, int ON_OFF, unsigned char* photo){
	Partner*p=GetPartner(uname);
	if(p==NULL){
		p=AddPartner(id,uname,ON_OFF);
	}else{
		p->ID=id;
		p->online=ON_OFF;
	}
	
	if(p==NULL){
		return;
	}
	
	if(p->pic==NULL)
		p->pic=new unsigned char[7500];
		
	int z=0;
	for(int x=0;x<3750;x+=3){
		p->pic[z++]=photo[x]&0xF0;
		p->pic[z++]=(photo[x]&0x0F)<<4;
		p->pic[z++]=photo[x+1]&0xF0;
		p->pic[z++]=(photo[x+1]&0x0F)<<4;
		p->pic[z++]=photo[x+2]&0xF0;
		p->pic[z++]=(photo[x+2]&0x0F)<<4;
	}
	
	long newsize;
	BYTE* Bbuf = ConvertRGBToBMPBuffer ( p->pic,PW,PH, &newsize );
	delete p->pic;
	p->pic=new BYTE[newsize];
	memcpy(p->pic,Bbuf,newsize);
	delete Bbuf;
}

void MainForm::NotifAuthPassed(){
	AuthPassed=1;
	ResyncAllSession();
}

void MainForm::NotifUserOffline(){
	GuiPrint("A felhasznl nincs belpve, nem tudsz neki kldeni!\n");
}

void MainForm::NotifUnameChg(int ID,char*name){
	Partner*p=GetPartner(ID);
	if(p==NULL){
		return;
	}
	strcpy(p->name.String,name);
	if(!TAB)DrawMainPanelUp();
	Sleep(100);
	//InvalidateRect(hwnd,NULL,TRUE);
	RECT r;
	r.left=MBVX;
	r.top=MBVY;
	r.right=MBVX+MBVW;
	r.bottom=MBVY+MBVH;
	InvalidateRect(hwnd,&r,TRUE);
}

void MainForm::NotifUremoved(int ID){
	Partner*p=GetPartner(ID);
	if(p==NULL){
		return;
	}
	char N[40];
	sprintf(N,"%d",ID);
	strcpy(p->name.String,N);
	p->online=0;
	if(!TAB)DrawMainPanelUp();
	Sleep(100);
	//InvalidateRect(hwnd,NULL,TRUE);
	RECT r;
	r.left=MBVX;
	r.top=MBVY;
	r.right=MBVX+MBVW;
	r.bottom=MBVY+MBVH;
	InvalidateRect(hwnd,&r,TRUE);
}

void MainForm::NotifUstatus(int ID,int state){
	Partner*p=GetPartner(ID);
	if(p==NULL){
		return;
	}
	p->online=state;
	
	if(p->ses){
		p->ses->scnt=0;
		TAB=SendMessage(TabControl1->GRhwnd,TCM_GETCURSEL,0,0);
		int orig=TAB;
		if(TAB!=p->ses->tab)
			SwitchToTabHidden(p->ses->tab);
		SetMainFont(-1);
		if(state==1)
			PutStrToMain("A felhasznl belpett\n");
		else
			PutStrToMain("A felhasznl kilpett\n");
		if(TAB!=orig)
			SwitchToTabHidden(orig);
		BlinkingTab(p->ses);
	}
	
	if(!TAB)DrawMainPanelUp();
	Sleep(100);
	//InvalidateRect(hwnd,NULL,TRUE);
	RECT r;
	r.left=MBVX;
	r.top=MBVY;
	r.right=MBVX+MBVW;
	r.bottom=MBVY+MBVH;
	InvalidateRect(hwnd,&r,TRUE);
}

//Route command from another client
void MainForm::RouteNotifMsg(int From,int Font,char*message){
	Partner*p=GetPartner(From);
	if(p==NULL){
		char pname[30];
		sprintf(pname,"%d",From);
		p=AddPartner(From,pname,1);
	}
	if(p->ses==NULL)
		AddSessionSpec(p,1);
	if(p->ses==NULL)
		return;
	EnterGUICritical();
	TAB=SendMessage(TabControl1->GRhwnd,TCM_GETCURSEL,0,0);
	int orig=TAB;
	if(TAB!=p->ses->tab)
		SwitchToTabHidden(p->ses->tab);
	SetMainFont(Font);
	//SpecialGUI=1;
	PutStrToMain(message);
	PutCharToMain('\n');
	//SpecialGUI=0;
	if(TAB!=orig)
		SwitchToTabHidden(orig);
	BlinkingTab(p->ses);
	Sleep(100);
	InvalidateRect(hwnd,NULL,TRUE);
	p->ses->rscnt=0;
	LeaveGUICritical();
}

//Udate main panel GUI
void MainForm::GuiUpdateNotif(){
	Sleep(500);
	TAB=SendMessage(TabControl1->GRhwnd,TCM_GETCURSEL,0,0);
	if(TAB==0){
		RECT r;
		r.left=POSZ;
		r.top=PSOR;
		r.right=POSZ+200;
		r.bottom=PSORMAX+PH;
		DrawMainPanelUp();
		Sleep(100);
		InvalidateRect(hwnd,&r,TRUE);
	}
}

//Network disconnected notification
void MainForm::NetDisconnectNotif(){
	if(ClientThreadRun){
		DestroyClient();
	}
	GuiPrint("Kapcsolat megszakadt!\n");
	AuthPassed=0;
	for (std::vector<Partner*>::iterator i = Partners.begin(); i != Partners.end(); ++i){
		(*i)->online=0;
	}
	GuiPrint("jracsatlakozs...\n");
	TryReconnect=40;
}

//Echo for alive command
void MainForm::ServerAlive(){
	AliveRet=0;
}

//key setter, getter functions for ClientApp
int& MainForm::getCSkey(int ID){
	Partner*p=GetPartner(ID);
	if(p==NULL)
		return TAB;	//DUMMY fals return;
	return p->cskey;
}
int& MainForm::getCRkey(int ID){
	Partner*p=GetPartner(ID);
	if(p==NULL)
		return TAB;	//DUMMY fals return;
	return p->crkey;
}
int  MainForm::setCSRkey(int KEY,int ID){
	Partner*p=GetPartner(ID);
	if(p==NULL)
		return KEY;
	if(p->ses==NULL){
		AddSessionSpec(p,1);
		if(p->ses)
			SwitchToTab(p->ses->tab);
	}
	if(p->ses==NULL)
		return KEY;
	
	if(p&&p->ses){
		p->crkey=KEY;
		p->cskey=KEY;
	}
	return KEY;
}

//not succeed sending to other client
void MainForm::NotitErrorCode(int From,int ecode){
	if(FsendThreadRun){
		GuiPrint("Nem sikerlt elkldeni a fjlt\n");
	}else{
		//try to resend last message
		Partner* p=GetPartner(From);
		if(p==NULL){
			GuiPrint("Nem sikerlt elkldeni az zenetet\n");
		}else if((p->ses)&&(p->ses->rscnt<=5)&&(AuthPassed)&&(p->online)){
			p->ses->rscnt++;
			//resend again
			int x;
			int poi=p->ses->bpoi;
			char* b=new char[1024];
			b[1023]=0;
			poi=(poi-1)&0x7FF;
			for(x=1022;x>=0;x--){
				poi=(poi-1)&0x7FF;
				b[x] = p->ses->buf[poi];
				if((b[x]==10)||(b[x]==13)||(b[x]==0))break;
			}
			x++;
			CRouteCmdKey(From, p->cskey);
			p->ses->scnt=0;
			if((b[x]!=10)&&(b[x]!=13)&&(b[x]!=0))
				CRouteScript(b+x, i->EditFont, From, p->cskey);
			delete b;
		}else{
			GuiPrint("Nem sikerlt elkldeni az zenetet\n");
		}
	}
}

void MainForm::FileHasSentNotif(int ID,int res){
	Partner*p=GetPartner(ID);
	if(p==NULL)
		return;
	if(p->ses==NULL){
		AddSessionSpec(p,1);
		if(p->ses)
			SwitchToTab(p->ses->tab);
	}
	if(p->ses==NULL)
		return;
	SetMainFont(0);
	if(res)
		PutStrToMain("A fjl elkldve\n");
	else
		PutStrToMain("A fjl klds hiba miatt megszakadt\n");
	Sleep(100);
	InvalidateRect(hwnd,NULL,TRUE);
}

void MainForm::FileReceivingNotif(int F,char*name){
	Partner*p=GetPartner(F);
	if(p==NULL)
		return;
	if(p->ses==NULL){
		AddSessionSpec(p,1);
		if(p->ses)
			SwitchToTab(p->ses->tab);
	}
	if(p->ses==NULL)
		return;
	
	SetMainFont(0);
	char msg[300];
	sprintf(msg,"Fjl fogadsa: %s\n",name);
	PutStrToMain(msg);
	Sleep(100);
	InvalidateRect(hwnd,NULL,TRUE);
}

void MainForm::FileReceivedNotif(int F,char*name){
	Partner*p=GetPartner(F);
	if(p==NULL)
		return;
	if(p->ses==NULL){
		AddSessionSpec(p,1);
		if(p->ses)
			SwitchToTab(p->ses->tab);
	}
	if(p->ses==NULL)
		return;
	SetMainFont(0);
	char msg[300];
	sprintf(msg,"Fjl fogadva: %s\n",name);
	PutStrToMain(msg);
	Sleep(100);
	InvalidateRect(hwnd,NULL,TRUE);
	p->ses->rscnt=0;
	
	if(YesNo("Kvnja-e megnyitni a fogadott fjlt tartalmaz mappt?")){
		AnsiString dir;
		AnsiString cmd;
		dir=ExtractFilePath(Application->ExeName)+"Download";
		cmd="explorer.exe ";
		cmd=cmd+dir;
		system(cmd.String);
	}
}

//----REQUESTS TO SERVER-----

void MainForm::SendScrMsgToServer(char*msg){
	if(!TAB)
		return;
	if(!AuthPassed)
		return;
	
	Session*ses=NULL;
	for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
		if( ((*j)->valid) && ((*j)->tab==TAB) ){
			ses=(*j);
			break;
		}
	}
	if(!ses||ses->part==NULL){
		return;
	}
	if(ses->part->ID==i->ID){
		SetMainFont(-1);
		PutStrToMain("\nnmagadnak nem tudsz kldeni!\n");
		Sleep(100);
		InvalidateRect(hwnd,NULL,TRUE);
		return;
	}
	if(ses->part->online==0){
		SetMainFont(-1);
		PutStrToMain("\nSajnos ");
		PutStrToMain(ses->part->name.String);
		PutStrToMain(" nem elrhet\n");
		Sleep(100);
		InvalidateRect(hwnd,NULL,TRUE);
		return;
	}
	if(ses->scnt==0){
		CRouteCmdKey(ses->part->ID, ses->part->cskey);
	}
	ses->scnt++;
	if(ses->scnt>20)
		ses->scnt=0;
	CRouteScript(msg, i->EditFont, ses->part->ID, ses->part->cskey);
}

//Request to Server to search for new partner
void MainForm::ServerReqAddPartner(AnsiString part){
	if(!AuthPassed)
		return;
	if(strlen(part.String)>20){
		GuiPrint("A nv nem lehet hosszabb 20 karakternl!\n");
		return;
	}
	if(!strcmp(i->Uname,part.String)){
		GuiPrint("nmagad nem tudod a partnerlistdhoz adni!\n");
		return;
	}
	char cmd[100]="add partner ";
	strcat(cmd,part.String);
	
	if(!AdminCmdInterp(cmd))
		GuiPrint("ERROR executing admin command\n");
	
/*
	ShowMessage(part);
	
	
	//TEST:
	//GET BUDDY.BMP and store to C++ source file
	AnsiString fn="E:\\Sajat\\GCC_projects\\MessengerBA\\Client\\buddy.bmp";
	HBITMAP MhbmpLOC;
	BITMAP bm;
	HDC hdc;
	HDC MhdcLOC;
	RECT r;
	//Print BMP GIF file into C source
	hdc=GetDC(hwnd);
	if(!hdc){MessageBox(hwnd, TEXT("ERROR: GetDC() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);return;}
	MhbmpLOC=(HBITMAP)LoadImage(NULL,fn.String,IMAGE_BITMAP,0,0,LR_LOADFROMFILE);
	if(!MhbmpLOC){MessageBox(hwnd, TEXT("ERROR: LoadImage() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);return;}
	MhdcLOC=CreateCompatibleDC(hdc);
	if(!MhdcLOC){MessageBox(hwnd, TEXT("ERROR: CreateCompatibleDC() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);return;}
	SelectObject ( MhdcLOC, MhbmpLOC );
	GetObject ( MhbmpLOC, sizeof(bm), &bm );
	int x,y;
	int c;
	int R;
	int G;
	int B;
	FILE*f;
	f=fopen("E:\\Sajat\\GCC_projects\\MessengerBA\\Client\\buddy.h","w");
	fprintf(f,"unsigned char buddy[]={\n");
	for(y=0;y<50;y++)
		for(x=0;x<50;x++){
			c=GetPixel(MhdcLOC,x,y);
			R=c&0xFF;
			G=(c&0xFF00)>>8;
			B=(c&0xFF0000)>>16;
			fprintf(f,"  %d,%d,%d,\n",B,G,R);
		}
	fprintf(f,"  0,0,0\n};\n");
	fclose(f);
	
	DeleteObject(MhbmpLOC);
	ReleaseDC(hwnd,hdc);
*/
}

void MainForm::ReqSendFileToClient(){
	if(!TAB)
		return;
	if(!AuthPassed)
		return;
	Session*ses=NULL;
	AnsiString FILETOSEND;
	OpenDialog1->Filter="File to send (*.*)\0*.*";
	if(OpenDialog1->Execute()){
		FILETOSEND=OpenDialog1->FileName;
		for (std::vector<Session*>::iterator j = Sessions.begin(); j != Sessions.end(); ++j){
			if( ((*j)->valid) && ((*j)->tab==TAB) ){
				ses=(*j);
				break;
			}
		}
		if(!ses||ses->part==NULL){
			return;
		}
		if(ses->part->ID==i->ID){
			SetMainFont(-1);
			PutStrToMain("\nnmagadnak nem tudsz kldeni!\n");
			Sleep(100);
			InvalidateRect(hwnd,NULL,TRUE);
			return;
		}
		if(ses->part->online==0){
			SetMainFont(-1);
			PutStrToMain("\nSajnos ");
			PutStrToMain(ses->part->name.String);
			PutStrToMain(" nem elrhet\n");
			Sleep(100);
			InvalidateRect(hwnd,NULL,TRUE);
			return;
		}
		CRouteCmdKey(ses->part->ID, ses->part->cskey);
		ses->scnt=0;
		SetMainFont(0);
		char fm[300];
		sprintf(fm,"Fjl kldse: %s\n",FILETOSEND.String);
		PutStrToMain(fm);
		Sleep(100);
		InvalidateRect(hwnd,NULL,TRUE);
		CRouteFileSend(ses->part->ID, FILETOSEND.String);
	}
}

void MainForm::ServerReqChangePic(){
	if(!AuthPassed)
		return;
	AnsiString PIC;
	if(Openpic->Execute()){
		PIC=Openpic->FileName;
		char cmd[200]="modify photo ";
		strcat(cmd,PIC.String);
		if(!AdminCmdInterp(cmd))
			GuiPrint("ERROR executing admin command\n");
	}
}

//check if admin command
//admin cmd must be <<admin command>>
int MainForm::AdminRequest(char* adm){
	int len=strlen(adm);
	if(len<5)
		return 0;
	if( (adm[0]=='<')&&(adm[1]=='<')&&(adm[len-1]=='>')&&(adm[len-2]=='>') ){
		char* acm;
		adm[len-2]=0;
		acm=adm+2;
		if(!AdminCmdInterp(acm)){
			SetMainFont(-1);
			PutStrToMain("\nERROR executing admin command");
			Sleep(100);
			InvalidateRect(hwnd,NULL,TRUE);
		}
		return 1;
	}
	return 0;
}

//Animation
void MainForm::LoadChangeFile(){
	int lines=0;
	unsigned long size;
	AnsiString AnimFile;
	AnimFile=ExtractFilePath(Application->ExeName)+CHANGELISTFILE;
	if(FileExists(AnimFile)){
		size = FileSize(AnimFile.String);
		if(size>65500)return;
		if(!sch)sch=new char[size+3];
		FILE*f=fopen(AnimFile.String,"rb");
		if(f){
			size=0;
			while(!feof(f)){
				sch[size]=fgetc(f);
				if(sch[size]==13)lines++;
				size++;
			}
			fclose(f);
		}else{
			return;
		}
	}else{
		return;
	}
	chlen=lines;
	lines+=2;
	if(!chnum)chnum=new char*[lines];
	if(!chstr)chstr=new char*[lines];
	sch[size]=13;sch[size+1]=10;
	int x;
	int l=0;
	int s=0;
	for(x=0;x<size;x++){
		switch(s){
			case 0:
				chnum[l]=sch+x;
				chstr[l]=NULL;
				s++;
				break;
			case 1:
				if(sch[x]==32){
					sch[x]=0;
					chstr[l]=sch+x+1;
					s++;
				}
				if(sch[x]==13){
					sch[x]=0;
					s=0;l++;x++;
				}
				break;
			case 2:
				if(sch[x]==13){
					sch[x]=0;
					s=0;l++;x++;
				}
				break;
		}
	}
	for(x=l;x<lines;x++){
		chnum[x]=NULL;
		chstr[x]=NULL;
	}
	//checking
	int err=0;
	for(x=0;x<chlen;x++){
		if(chstr[x]==NULL){
			ShowMessage("ERROR Hiba az Animcikat prost fjlban! - 1");
			err=1;
			break;
		}
		if(strlen(chnum[x])!=4){
			ShowMessage("ERROR Hiba az Animcikat prost fjlban! - 2");
			err=1;
			break;
		}
	}
	//delete all on error
	if(err==1){
		if(sch)delete[] sch;
		if(chnum)delete[] chnum;
		if(chstr)delete[] chstr;
		sch=NULL;
		chnum=NULL;
		chstr=NULL;
	}
}

//Animation
void MainForm::ChangeToAnim(){
	if(!sch||!chnum||!chstr)
		return;
	int x,y;
	char*c;
	int len;
	int cx;
	for(x=0;x<chlen;x++){
		if(chstr[x]==NULL)break;
		while(c=strstr(Editbuf,chstr[x])){
			len=strlen(chstr[x]);
			cx=c-Editbuf;
			if((cx<0)||(cx>1023))break;
			if(len>4){
				for(y=cx+4;y<1024-len+4;y++)
					Editbuf[y]=Editbuf[y+len-4];
			}else if(len<4){
				for(y=1023;y>=cx+4;y--)
					Editbuf[y]=Editbuf[y+len-4];
				Editbuf[1023]=0;
			}
			for(y=0;y<4;y++)
				c[y]=chnum[x][y];
		}
	}
}

void MainForm::SetAnimate(){
	AnsiString AnimFileHidden;
	AnimFileHidden=ExtractFilePath(Application->ExeName)+CHANGELISTFILEDEACT;
	AnsiString AnimFile;
	AnimFile=ExtractFilePath(Application->ExeName)+CHANGELISTFILE;
	int res=1;
	if(MessageBox(NULL,"Engedlyezi-e az automatikus animcikat a szlistban bejegyzett szavakra?","Animcik belltsa",MB_YESNO) == IDYES){
		if(FileExists(AnimFileHidden)){
			res=MoveFile(AnimFileHidden.String,AnimFile.String);
		}
		LoadChangeFile();
	}else{
		if(FileExists(AnimFile)){
			res=MoveFile(AnimFile.String,AnimFileHidden.String);
		}
		if(sch)delete[] sch;
		if(chnum)delete[] chnum;
		if(chstr)delete[] chstr;
		sch=NULL;
		chnum=NULL;
		chstr=NULL;
	}
	if(!res){
		ShowError("Hiba! Nem sikerlt belltani az animcikat!","ERROR: Animcik belltsa");
	}
}
