//Chat Bot Motor Andras Bognar 2012
#include "Chat.h"
#include <math.h>

ChatBot::ChatBot(){
	responsetime=0;   replytext="";
	inactivity=0;
	firstrule=new TStringList();
	firstrule->LoadFromFile(RULEFIRST);
	secondrule=new TStringList();
	secondrule->LoadFromFile(RULESECOND);
	notunderstand=new TStringList();
	notunderstand->Add(":Hm??  haha");
	notunderstand->Add(":Hm?");
	notunderstand->Add(":Jah");
	notunderstand->Add(":ja");
	notunderstand->Add(":jah haha");
	notunderstand->Add(":nem rtem de mindegy");
	notunderstand->Add(":hmmm...");
	notunderstand->Add(":nem tudom.");
	notunderstand->Add(":nos");
	notunderstand->Add(":ht szoval..");
	boredmsg=new TStringList();
	boredmsg->Add("Mizujs? rj mr valamit!");
	boredmsg->Add("Hah? itt vagy? rj!");
	boredmsg->Add("Merre vagy? a Holdra mentl?");
	boredmsg->Add("rj valamit !");
	boredmsg->Add("Mrt nem rsz semmit?");
	boredmsg->Add("Elmentl ?");
	boredmsg->Add("Gyere vissza! Krlek ...rj!");
	boredmsg->Add("Br itt lennl...rj!");
	boredmsg->Add("Annyira vrlak mr... lgy itt.. s rj!");
	boredmsg->Add("Na mi az dolgozol kemnyen?");
	//RandSeed=11;
	unknown=new TStringList();//for unknown question saving
	unknown->LoadFromFile(UNKNOWNQ);
	u="";
	FILE *urandom;
    unsigned int seed;
    urandom = fopen ("/dev/urandom", "r"); 
    if (urandom == NULL){
        ErrorAlert("ERROR opening /dev/urandom","Randomseed generator");
    }else{
        fread (&seed, sizeof (seed), 1, urandom);
        fclose(urandom);
        srand (seed);
    }
	replytext="";
}

ChatBot::~ChatBot(){
	//Destroy all
	delete firstrule;
	delete secondrule;
	delete notunderstand;
	unknown->SaveToFile(UNKNOWNQ);
	delete unknown;
	delete boredmsg;
}

//Ekezetek kezelese:
//hosszu i-> rvid i
//hosszu A-> rvid A
//hosszu u-> rvid u
AnsiString ChatBot::ekezet(AnsiString s){
	int x;
	for(x=1;x<s.Length()+1;x++){
		if(s[x]=='')
			s[x]='';
		if(s[x]=='')
			s[x]='';
		if(s[x]=='')
			s[x]='i';
		if(s[x]=='')
			s[x]='';
		if(s[x]=='')
			s[x]='';
		if(s[x]=='')
			s[x]='I';
	}
	return s;
}

//Split string to strings: separator= ' '
int ChatBot::Split(TStringList*parts,AnsiString s){
	int start=1,end=2;
	int numofparts=0;
	if((s.IsEmpty())||(s==" "))return 0;
	if(s[s.Length()]==' ')s.Delete(s.Length(),1);
	while(end<s.Length()){
		if(s[end]==' '){
			parts->Add(s.SubString(start,end-start)); start=end+1;
			numofparts++;
		}
		end++;
	}
	if(start<s.Length()+1){
		parts->Add(s.SubString(start,end-start+1));
		numofparts++;
	}
	return numofparts;
}

//Special Str compare
//pos=found position oper=rule operator
//1=found 0=not found
int ChatBot::Strc(AnsiString input,AnsiString s,int & oper,int & pos){
	if(s[s.Length()]=='+'){
		oper='+';s.Delete(s.Length(),1);
	}else if(s[s.Length()]=='|'){
		oper='|';s.Delete(s.Length(),1);
	}else if(s[s.Length()]=='>'){
		oper=' ';s.Delete(s.Length(),1);
	}else oper=' ';
	pos=input.Pos(s);
	if(!pos)return 0;
	else return 1;
}

//1-teljesul, 0-nem
int ChatBot::rule2(AnsiString input,AnsiString rule){
	TStringList* part=new(TStringList);
	int numpart=Split(part,rule);
	int x,oper,pos,actpos=0,res;
	int ortrue=0,orexist=0;
	if(part->Strings[0]=="#"){
		for(x=1;x<numpart;x++){
			if((part->Strings[x][part->Strings[x].Length()]=='|')&&(ortrue))continue;
			res=Strc(input,part->Strings[x],oper,pos);
			if(oper=='|')orexist=1;
			if(((oper==' ')||(oper=='+'))&&(!res)){delete part;return 0;}
			if((oper==' ')&&(actpos>pos)){delete part;return 0;}
			if((oper=='|')&&(res))ortrue=1;
			actpos=pos;
		}
	}
	else {delete part;return 0;}//Nem rule - error

	delete part;
	if(orexist&&!ortrue)return 0;
	else return 1;
}

//Search the line begin with '#'
int ChatBot::SearchHashmark(TStringList*list,AnsiString s){
	int pos=0;
	AnsiString c;
	do{
		if(list->Strings[pos][1]=='#'){
			c=list->Strings[pos];
			c.Delete(1,1);
			if(!c.AnsiCompareIC(s))break;
		}
		pos++;
	}
	while(pos<list->Count);
	if(pos>list->Count-1)return -1;
	return pos;
}

//Returns the number of lines begin with ':'
int ChatBot::SearchDPoint(TStringList*list,int &pos){
	int num=0;
	int x=pos;
	do{
		if(list->Strings[x].IsEmpty())break;
		if(list->Strings[x][1]==':')break;
		x++;pos++;
	}
	while(pos<list->Count);
	do{
    	if(list->Strings[x].IsEmpty())break;
		if(list->Strings[x][1]!=':')break;
		x++;num++;
	}
	while(x<list->Count);
	return num;
}



//RND number from 1 to x
int ChatBot::RND(int x){
	int num;
	num=rand()%x+1;
	return num;
}

//Replying
void ChatBot::reply(){
	int pos,num,ok;
	responsetime=2;

	pos=SearchHashmark(firstrule,input);
	if(pos==-1){
		pos=0;

		while(pos<secondrule->Count){
			if(!(secondrule->Strings[pos].IsEmpty())&&(secondrule->Strings[pos][1]=='#')){
				ok=rule2(input,secondrule->Strings[pos]);
				if(ok){
					num=SearchDPoint(secondrule,pos);
					pos=pos+RND(num)-1;
					replytext=secondrule->Strings[pos];
					return;
				}
			}
			pos++;
		}
		if(pos>secondrule->Count-1){
			num=10;pos=RND(num)-1;
			replytext=notunderstand->Strings[pos];
			unknown->Add(u+"# "+input);
			return;
		}
	}
	num=SearchDPoint(firstrule,pos);
	pos=pos+RND(num)-1;
	replytext=firstrule->Strings[pos];
}

//Send a new line to machine
void ChatBot::sendline(AnsiString line){
	//SEND
	inactivity=0;
	input=line;
	input.LowerCase();
	input=ekezet(input);
	u="";
	u=u+"Bot: "+input;
	reply();
	replytext.Delete(1,1);
}

void ChatBot::GetBoredMsg(){
	replytext=boredmsg->Strings[RND(10)-1];
}

void ChatBot::ClientConnect(){
	replytext="Szia, Mizujs?";
}
