//Label Class

#include "LabelClass.h"
extern int IDord;


Label::Label(HWND hwnd,HINSTANCE hinst,char* Caption,int* Size):
Caption(this, &Label::GetCaption, &Label::SetCaption, &Label::GetRefCaption)
{
    LabelHwnd =
    CreateWindow("Static",
                 Caption,
                 WS_CHILD | WS_VISIBLE,
                 Size[0],Size[1],Size[2],Size[3],
                 hwnd,0,hinst,0);

    ID=IDord++;
    
    CaptionText.LoadStr(Caption);
	hFont=NULL;
	
	LabelProcAddr = (WNDPROC)GetWindowLong(LabelHwnd, GWL_WNDPROC);
	SetWindowLong(LabelHwnd, GWL_WNDPROC, reinterpret_cast<LONG_PTR>(&Label::StatWndProc));
}

Label::~Label(){
	//if(hFont)DeleteObject(hFont);
}

void Label::SetCaption(const AnsiString & str){
    CaptionText=str;
    SetWindowText(LabelHwnd,CaptionText.c_str());
}

const AnsiString & Label::GetCaption()const{
   return CaptionText;
}

AnsiString & Label::GetRefCaption(){
   return CaptionText;
}

void Label::SetDefFont(){
	hFont = CreateFont(-11,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, VARIABLE_PITCH,TEXT("Tahoma"));
	SendMessage(LabelHwnd,WM_SETFONT ,(WPARAM)hFont,true);
}
