//OPENFILENAME
//File opening dialog box
#ifndef OpenFileClassH
#define OpenFileClassH

#include "AnsiString.h"

class TOpenPictureDialog{
    OPENFILENAME ofn;
    HWND ownerwin;
  public:
    TOpenPictureDialog(HWND hwnd);
    ~TOpenPictureDialog();
    bool Execute();
    AnsiString FileName;
};

class TOpenDialog{
    OPENFILENAME ofn;
    HWND ownerwin;
public:
	TOpenDialog(HWND hwnd);
	~TOpenDialog();
    bool Execute();
    AnsiString FileName;
	char* Filter;
};

class TSaveDialog{
    OPENFILENAME ofn;
    HWND ownerwin;
public:
	TSaveDialog(HWND hwnd);
	~TSaveDialog();
    bool Execute();
    AnsiString FileName;
	char* Filter;	
};

#endif


/*
	OpenDialog1->Filter="ASSEMBLY source file (*.asm)|*.ASM";
	if(OpenDialog1->Execute()){
         BINfileName=OpenDialog1->FileName;

    SaveDialog1->Filter="BASIC source file (*.basic)|*.BASIC";
	if(SaveDialog1->Execute()){
		INPUTfile=SaveDialog1->FileName;


*/
