//Semaphore class
#include "Semaphore.h"
#include "AnsiString.h"

Semaphore::Semaphore(int init, int max){
    hSema = CreateSemaphore( 
        NULL,   // default security attributes
        init,   // initial count
        max,    // maximum count
        NULL);  // unnamed semaphore

    if (hSema == NULL) {
        ShowMessage("Create Semaphore failed");
    }
}

Semaphore::~Semaphore(){
	if(hSema)CloseHandle(hSema);
}

int Semaphore::WaitFor(int time){
	return WaitForSingleObject(hSema,time);
}

void Semaphore::Release(){
	if (!ReleaseSemaphore( hSema, 1, NULL) ){
		//ShowMessage("ReleaseSemaphore error");
	}
}
