//TStringList Class
#ifndef TStringListClassH
#define TStringListClassH
#include "AnsiString.h"

#define COUNTMAX 0x7FFFFFFA	//the absolut maximum of line count.

class TStringList;

class StringElem{
  public:
	TStringList* Own;
	StringElem(){}
	~StringElem(){}
	AnsiString& operator[] (long i);
	AnsiString& operator[] (unsigned i);
	AnsiString& operator[] (int i);
};

class TextElem{
  public:
	AnsiString Element;
	TextElem* FW;
	TextElem* BK;
	TextElem(){}
	~TextElem(){}
};

class TStringList{
	TextElem* Root;
	TextElem* Tail;
	TextElem* Act;
	long ActIndex;
  public:
	TStringList();
	~TStringList();
	long Count;
	StringElem Strings;
	bool LoadFromFile(char* fname);
	bool LoadFromFile(AnsiString& fname);
	bool SaveToFile(char* fname);
	bool SaveToFile(AnsiString& fname);
	void Insert(long i, char* str);
	void Insert(long index, AnsiString str);
	void Delete(long i);
	void Insert(unsigned i, char* str);
	void Insert(unsigned index, AnsiString str);
	void Delete(unsigned i);
	void Delete(int i);
	void Clear();
	void Add(AnsiString str);
	void Add(char* str);
	TextElem* GetElemByIndex(long i);
};

#endif

/*
TStringList:

clist=new(TStringList);
clist->LoadFromFile(INPUTfile);
clist->SaveToFile("d:\\_asm.asm");
clist->Insert(0,"");
clist->Count
s=clist->Strings[x];	//Nullatol van indexelve 
clist->Clear();
clist->Delete(int elem)
clist->Add(Ansistring)
*/
